/******************************************************* {COPYRIGHT-TOP-OCO} ***
 * Licensed Materials - Property of IBM
 *
 * 5724-C51
 *
 * (C) Copyright IBM Corp. 2007 All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication, or
 * disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 ******************************************************* {COPYRIGHT-END-OCO} ***/
/*******************************************************************************
 * CMVC Location: radCommonInstallBase/guifoundation/webapps/netcool/scripts/script.js, tbsm_rad, tbsm_rad_3.0
 * Version:       1.2
 * Last Modified: 07/04/09 13:13:15
 *******************************************************************************/


/*****************************************************************************
* BEGIN common library of general usefulness                                 *
******************************************************************************/
// Browser variables
var w3c=(document.getElementById)? true: false;
var ie=(w3c && document.all)? true : false;
var ns=(w3c && (navigator.appName=="Netscape"))? true : false;

// Characters that are illegal for data type names.
var illegalChars = "' \" ! $ % <space> <tab> / \\";


function selectAll(sel) {
  for (i = 0; i < sel.length; i++)
    sel.options[i].selected = true;
}

function swapImage(img_name, img_src ) {
	if ( !img_name ) return;
  eval("document."+img_name+".src=img_src");
}

function submitForm(form, href) {
	eval("document."+form+".action=href");
	var fakebutton = eval("document." + form + ".fakesubmitbutton");
	if ( fakebutton ) fakebutton.click();
	else eval("document."+form+".submit()");
}

function submitFormToTarget(form, href, targetPage) {
  eval("document."+form+".target=targetPage");
  eval("document."+form+".action=href");
	var fakebutton = eval("document." + form + ".fakesubmitbutton");
	if ( fakebutton ) fakebutton.click();
  else eval("document."+form+".submit()");
}

function changeNumberValue(name, increase, min, max, unit) {
  var temp = parseInt(name.value);
  if(increase) {
    temp+=unit;
  } else {
    temp-=unit;
  }
  if(!verifyRange(min, max, temp)){
    return;
  }
  name.value=temp;
}

function increaseNumber(name) {
  var origValue = name.value;
  var temp = parseInt(name.value);
  temp++;
  name.value=temp;
}

function closeWindow(windowName) {
  window.close();
}
function containsSpace(string) {
  for(var i=0; i<string.length; i++) {
    if(string.charAt(i) == ' ') {
      alert('Spaces are not allowed. You may use characters such as underscores or hypens to indicate spaces.');
      return true;
    }
  }
  return false;
}
function isInteger(val) {
	for(var i=0; i<val.length;i++) {
	   if(!isDigit(val.charAt(i))) {
	      		return false;
            }
	}
	return true;
}

function isDigit(num) {
	var string="1234567890";
	if (string.indexOf(num) != -1) {
	   return true;
	}
	return false;
}

function getRandom() {
  return (Math.random());
}

function trim(input) {
  var retval = "";
  var counter = 0;
  var counter2 = input.length - 1;
  var ch = input.charAt(counter);

  if(input == null || input.length < 1)
    return retval;

  // strip beginning
  while(counter < input.length &&
   (ch == ' ' || ch == '\n' || ch == '\t' || ch == '\r') ) {
  counter++;
  ch = input.charAt(counter);
  }

  // strip end
  ch = input.charAt(counter2);

  while(counter2 > -1 &&
   (ch == ' ' || ch == '\n' || ch == '\t' || ch == '\r') ) {
  counter2--;
  ch = input.charAt(counter2);
  }

  if(counter > counter2) return retval;

  for( ; counter != (counter2 + 1); counter++) {
  retval += input.charAt(counter);
  }

  return retval;

} // endfunc trim


// Check if input is digits including decimal and sign
// if the sign boolean is true
// @param input the input text
// @param sign true, to allow sign numbers
// @param decimal true, to allow decimal 
// @return true if input is all digits 
function isInputNumber(input, sign, decimal) {
  if(input.length == 0) return false;  
  var numbers = "0123456789";
	if ( decimal ) numbers = numbers+".";
  if ( sign ) numbers = numbers+"-";
  for(var i=0; i < input.length; i++) {        
    if(numbers.indexOf(input.charAt(i)) < 0) {                          
      return false;
    }                                                                   
  }                                                                     
                                                                             
  return true;   
} // endfunc isInputNumber

// check for empty input condition
// @param input  input to be checked for empty condition
// @return true if input is empty or all whitespace, false otherwise
function isBlank(input) {

  for(var i=0; i < input.length; i++) {
    var ch = input.charAt(i);
    if( ch!=' ' && ch!='\n' && ch!='\t' && ch!='\r' ) {
      return false;
    }
  }

  return true;

} // endfunc isBlank

// checks to see if input actully is defined and is not
// null - can use to determine if input params are defined
function isDefined(input) {
  if (typeof(input) == "undefined" || input == null) {
    return (false);
  }
  return (true);
}

// checks to see if input is digits only
// @param input  Check this var to see if it contains all digits
// @return true if input is numerical ( >=0, no decimals, signs)
function isNumber(input) {

  if(input.length == 0) return false;

  var numbers = "0123456789";
  for(var i=0; i < input.length; i++) {
    if(numbers.indexOf(input.charAt(i)) < 0) {
      return false;
    }
  }

  return true;

} // endfunc isNumber

// checks to see if input is digits only
// @param input  Check this var to see if it contains all digits
// @return true if input is numerical ( >=0, no decimals, signs)
function isAlphaNumeric(input) {

  if(input.length == 0) return false;

  var ch;

  for(var i=0; i < input.length; i++) {

    ch = input.charAt(i);

    if( !(ch >= 'a' && ch <= 'z' ||
          ch >= 'A' && ch <= 'Z' ||
          ch >= '0' && ch <= '9' ||
          ch == ' ' ) ) {
          return false;
    } // endif
  } // endfor

  return true;

} // endfunc isAlphaNumeric

// containsIllegalChars
// Checks to see if input doesn't contain an illegal chars
// as defined by illegalChars = "'\"!$%<space><tab>/\\";
// @param input  Check this var to see if it contains any invalid char.
// @return true if input is bad char free. 
function containsIllegalChars(input) {
  if(containsSpace(input)) {
    return true;
  }
  var ch;
  
  for(var i = 0; i < input.length; i++) {

    ch = input.charAt(i);
    
    if (ch == '\'' ||
	ch == '\"' ||
	ch == '!' ||
        ch == '$' ||
        ch == '%' ||
        ch == '/' ||
        ch == '\\' ) {
      
      alert('Special character '+ch+ ' not allowed.');
      return true;
    } // endif	
  } // endfor	

  return false;

} // endfun containsIllegalChars



// @param min   Minimum number in range, inclusive
// @param max   Maximum number in range, inclusive
// @param input Check this number to see if in between min and max
// @return true if range of input is in between the min/max inclusive
function verifyRange(min, max, input) {

  if( (input < min) || (input > max) ) return false;
  else return true;

} // endfunc verifyRange

//validate the passed string parameter is a vaildate email address
function isValidEmail(strEmail) {
  validRegExp =/^[^@]+@[^@]+.[a-z]{2,}$/i;
  if(strEmail.search(validRegExp) == -1) {
    alert('A valid e-mail address is required.\nPlease enter a validate one');
    return false;
  }
  return true;
}

// counts number of options in a Select object that have been selected
// @param selectobj  SELECT object with OPTIONs
// @return number of items selected in list
function countSelections(selectobj) {

  var select_counter = 0;

  for(var i = 0; i < selectobj.options.length; i++) {
    if(selectobj.options[i].selected) select_counter++;
  }

  return select_counter;

} // endfunc countSelections




// checks to see if string item is not already contained within a
// Select object's list item, either as a substring, or an entire match
// @param item    The item string to be searched for in Select list
// @param selobj  The Select object
// @param exact  true if whole item should match, false if substring
// @return      index of option found, or -1 if not found
function findItemInList(item, selobj, exact) {

  if(!exact) {
    for(var i = 0; i < selobj.options.length; i++)
      if( selobj.options[i].text.indexOf(item) != -1 )
        return i; // item found
  }
  else for(var i = 0; i < selobj.options.length; i++)
    if( selobj.options[i].text == item)
      return i; // exact match found

  return -1;   // item was not found

} // endfunc findItemInList

/*
 * Returns true if element is an input control of type checkbox.
 */
function isCheckBox(element) {
  if (typeof(element.getAttribute("type")) != "undefined") {
    if (element.getAttribute("type") == "CHECKBOX" ||
        element.getAttribute("type") == "checkbox") {
      //alert("Found checkbox");
      return (true);
    }
  }
  return (false);
}

/*
 * Returns request params string creataed from a form elements array. Returns
 * an empty string if formElements is null or does not contain any elements.
 */
function getRequestParamsStr(formElements, leaveOffQuestionMark) {
  var paramsList = new String("");
  var regExp = /\+/g;
  if (formElements != null) {
    for (var i = 0; i < formElements.length; i++) {
      if (!isCheckBox(formElements[i]) ||
          (isCheckBox(formElements[i]) && formElements[i].checked)) {
        if (i == 0) {
          if (leaveOffQuestionMark) {
            paramsList = escape(formElements[i].name)+"="+
              (String(escape(formElements[i].value)).replace(regExp, "%2B"));
          } else {
            paramsList = "?"+escape(formElements[i].name)+"="+
              (String(escape(formElements[i].value)).replace(regExp, "%2B"));
          }
        } else {
          paramsList += "&"+escape(formElements[i].name)+"="+
            (String(escape(formElements[i].value)).replace(regExp, "%2B"));
        }
      }
    }
  }
  return (paramsList);
}

/**
 * Get the coordinates of the center of the screen. Use this
 * to center the new window on the screen
 * @param width width of the new window
 * @param height height of the new window
 * @return the center coordinates in an array - first element is x
 * and second element is y
 */
function getCenterCoordinates(width, height) {
	var x = (screen.width/2) - (width/2);
	var y = (screen.height/2) - (height/2);

	return new Array(x, y);
}

//-- START: Form Check
/**
 * Check the required fields 
 * @param fieldRequired an array of required fields
 * @param fieldDescription an array of required field description
 */
var saveformbgcolor = Array();
function validateRequiredFields(formobj, fieldRequired, fieldDescription) {
	// dialog message
	var alertMsg = "Please complete the following fields:\n";
	var warningcolor = "#FF0000";
	var l_Msg = alertMsg.length;
	var count = 0;
	
	for (var i = 0; i < fieldRequired.length; i++) {
		var obj = formobj.elements[fieldRequired[i]];
		if (obj) {
			if ( !saveformbgcolor[fieldRequired[i]] ) {
				if ( obj.style.background && obj.style.background != '' )
					saveformbgcolor[fieldRequired[i]] = obj.style.backgroundColor;
				else
					saveformbgcolor[fieldRequired[i]] = '#FFFFFF';
			}
			obj.style.backgroundColor = saveformbgcolor[fieldRequired[i]];
			switch(obj.type){
			case "select-one":
				if (obj.selectedIndex == -1 || obj.options[obj.selectedIndex].text == "" || 
					  obj.options[obj.selectedIndex].text == "Choose One" ||
						obj.options[obj.selectedIndex].text == "Please Select" ) {
					obj.style.backgroundColor=warningcolor;
					alertMsg += " - " + fieldDescription[i] + "\n";
					count++;
				}
				break;
			case "select-multiple":
				if (obj.selectedIndex == -1) {
					alertMsg += " - " + fieldDescription[i] + "\n";
					obj.style.backgroundColor=warningcolor;
					count++;
				}
				break;
			case "text":
			case "textarea":
				if (obj.value == "" || obj.value == null) {
					obj.style.backgroundColor=warningcolor;
					alertMsg += " - " + fieldDescription[i] + "\n";
					count++;
				} else if ( (obj.fieldtype == 'int') && 
								(isInputNumber(obj.value)) ) {
					obj.style.backgroundColor=warningcolor;
					alertMsg += " - " + fieldDescription[i] + ". *It must be an integer.*\n";
					count++;
				}
				break;
			default:
			}
			if (obj.type == undefined) {
				var blnchecked = false;
				for (var j = 0; j < obj.length; j++) {
					if (obj[j].checked) {
						blnchecked = true;
					}
				}
				if (!blnchecked) {
					alertMsg += " - " + fieldDescription[i] + "\n";
					count++;
				}
			}
		}
	}

	if (alertMsg.length == l_Msg) {
		return true;
	} else {
		alertMsg = alertMsg.substring(0, alertMsg.length - 2);
		//if ( window.popup_DOMWindow_text ) {
			alertMsg = alertMsg + '<br><br><center><img src="/netcool/images/button_close.png" onClick="hidebox(\'errorcid\');"></center>';
		//	popup_DOMWindow_text('errorcid', alertMsg, 'Error: Required fields not completed', 300, Math.max((count*55)+40, 120)); 
		//} else alert(alertMsg); 
		alert(alertMsg); 
		return false;
	}
}
//-- END: Form Check

/*****************************************************************************
 * Error Message Handling Functions                                          *
 ****************************************************************************/

// Function to display an error in a Javascipt "alert"
// message box.
function report_error(error, msg) {
  var regExp = /\+/g;
  if(!error) {
    alert(unescape(String(msg).replace(regExp, ' ')));
  }
} // end function report_error


// pops up new window with url, stripped of most accoutrements, and
// centers it to the screen
// (would've loved to center it to center of calling window but
// the properties required for this op are only under Navigator)
// this window can act as a confirmation dialog to replace confirm()
function minimal_popup(url,target,wd,ht,scroll) {

  var scrolltxt = "no";
	var coord = getCenterCoordinates(wd, ht);
	var screenX = ns?'screenX='+coord[0]:'left='+coord[0];
	var screenY = ns?'screenY='+coord[1]:'top='+coord[1];

  if(scroll) scrolltxt="yes";

  weasel = window.open(url,target,
    'width='+wd+',height='+ht+','+screenX+','+screenY+ 
    ',status=no,resizeable=no,toolbar=no,location=no,menubar=no,directories=no,scrollbars='+ 
    scrolltxt,true);

  // Use screenX and screenY in call to open instead of moveTo so 
  // don't see the window flicker on screen.
  //weasel.moveTo(screen.width/2 - wd/2, screen.height/2 - ht/2);

} // endfunc minimal_popup


// Function to display default error page in a minimal popup browser. Can be 
// used in onLoad method of page to detect and report any errors encountered 
// in the page. The error msg passed through this function no longer has to 
// be URLEncoded, or escaped. It will be taken care of internally to this 
// function. No harm done if already encoding.
function popup_error(error, msg, contextPath) {
  if (error) {
    var url = contextPath ? contextPath : "";
    url += "/servlet/com.micromuse.common.htmlcomponents.servlets.NCErrorServlet?error=";

   // NCErrorPage will take care of decoding the msg.
   minimal_popup(url+escape(msg), "errorPage", 500, 250, true);
  } 
} // end function popup_error


// Function to bypass loading of current page and redirect to default error page.
function redirect_error(error, msg, contextPath) {
  if (error) {
    var url = contextPath ? contextPath : "";
    url += "/servlet/com.micromuse.common.htmlcomponents.servlets.NCErrorServlet?error=";

    window.top.location = url+escape(msg);
  } 
}
/*****************************************************************************
* END common library of general usefulness                                   *
******************************************************************************/

/******************************************************************************
* START NCDoubleComboBoxBasic specific functions.                             *
******************************************************************************/
function DoubleCombo_optionSelected(listname, formname) {

  // 1. get selected index of listname_1
  // 2. retrieve value of the option at this index
  // 3. clear current secondary list
  // 4. using listname.value, loop through array and populate second list

  var prefix = "document." + formname + "." + listname;
  var primary = eval(prefix + "_1");      // points to primary Select
  var secondary = eval(prefix + "_2");  // points to secondary Select

  var idx = primary.selectedIndex;
  if(idx < 0) { return; } // nothing selected

  var val = primary.options[idx].value;

  // 3
  secondary.options.length=0;

  // 4
  if( null == eval(listname + "." + val) ) { return; }  // no secondary list

  var listlen = eval(listname + "." + val + ".length");
  var itemtext;
  var itemval;

  for(var i = 0; i < listlen; i++) {
    itemtext = eval(listname + "." + val + "[" + i + "].text");
    itemval = eval(listname + "." + val + "[" + i + "].value");
    secondary.options[i] = new Option(itemtext, itemval);
  }

} // endfn DoubleCombo_optionSelected


function DoubleCombo_selectSecondOption(optvalue, listname, formname) {

  // 1. loop through secondary list
  // 2. find match to optvalue
  // 3. set second list selection by index of the matched item

  // ref to second list
  var list2 = eval("document." + formname + "." + listname + "_2");

  var listlen = list2.options.length;
  var itemval;

  for(var i = 0; i < listlen; i++) {
    itemval = list2.options[i].value;
    if(itemval == optvalue) {
      list2.selectedIndex = i; // found! select and get out.
      return;
    }
  }

  return; // value not found, no selection made

} // endfn DoubleCombo_optionSelected

/******************************************************************************
* END NCDoubleComboBoxBasic specific functions.                               *
******************************************************************************/

function do_help_button(href) {
  window.open(href);
}


//move the scripts frame.js to here
/**
 * frame.js is used as the helper of modal dialog. if appliaction 
 * wanna the popup window to be a modal dialog, application will have
 * to include this script file into the very top frame
 */

var newWin;
 
function ignoreEvents(e)
{
  if(!newWin.closed) {
    return false;
  }
}

function focusing() {
  if(newWin && !newWin.closed) {
    newWin.focus();
  }
}

function launchModalDialog(url, winName, w,  h, multiWindow) {
  var winName = ""; 
  var multi = multiWindow ? multiWindow : false;
	var coor = getCenterCoordinates(w, h);
	var screenX = ns?'screenX='+coor[0]:'left='+coor[0];
	var screenY = ns?'screenY='+coor[1]:'top='+coor[1];
  newWin = window.open(url,winName,'width='+w+',height='+h+',status=no,scrollbars=yes,resizable=yes,dependent=yes,'+screenX+','+screenY);
  if(!multi) {
    blockMyFrames(window.top);
  }
  newWin.focus();
}

function blockMyFrames(myWin) {
  if (myWin.frames != null ) {
    for (var i=0; i < myWin.frames.length; i++) {
      window.top.blockMyFrames(myWin.frames[i]);
    }
  }
  myWin.document.body.onfocus=window.top.focusing;
  myWin.document.body.onclick=window.top.focusing;
  myWin.document.body.ondbclick=window.top.focusing;
  myWin.onfocus=window.top.focusing;
}
//end of frame.js

/**
 *Simulation of a modal dialog. This dialog will always stays on top. 
 */
//alert(navigator.appName);
var Nav4=((navigator.appName == "Netscape")&&(parseInt(navigator.appVersion) >=4));
var IE=(navigator.appName == "Microsoft Internet Explorer");
var winModalWindow = null;
 
function ignoreEvents(e)
{
  return false;
}

function focusOnPopup() {
  if (winModalWindow != null && !winModalWindow.closed){
    winModalWindow.focus();
  }
}

function handleFocus()
{
  if (winModalWindow != null) {
    if (!winModalWindow.closed) {
       winModalWindow.focus()
    } else {
      window.top.releaseEvents(Event.CLICK|Event.FOCUS);
    }
  }
  return false;
}

function showDialogWindow(url, windowName, w, h, multiWindow) {
  if(typeof(w) == "undefined") {
    w=400;
  }
  if(typeof(h) == "undefined") {
    h=300;
  }
  if(!Nav4) {
    w += 50;
    h += 50;
    window.top.launchModalDialog(url, windowName, w, h, multiWindow);
  } else {
		var coor = getCenterCoordinates(w, h);
		var screenX = coor[0];
		var screenY = coor[1];
    winModalWindow = window.open(url, windowName,'width='+w+',height='+h+',status=no,scrollbars=yes,resizable=yes,dependent=yes,screenX='+screenX+',screenY='+screenY);
    window.top.captureEvents(Event.CLICK|Event.FOCUS);
    window.top.onfocus=handleFocus;
    window.top.onclick=ignoreEvents;
    if (winModalWindow != null) {
      winModalWindow.focus();
    }
  }
  
}
/******************************************************************************
* END of modal dialog specific functions.                                     *
******************************************************************************/

/******************************************************************************
* Functions to find frames by frameName in multi-framed environments.         *
******************************************************************************/
/*
 * Function to find and return a reference to a frame window based on the
 * given frameName. Frames must have unique names to ensure proper frame object 
 * is returned. If more than one frame exists with the same name, the frame 
 * window object for the first one found will be returned.
 */
function findFrameObj(frameName) {
  var i, j = 0;
  var parentObj = top;
  var frameObj = null;
  var done = false;
  var nextArray = new Array();

  if (!isDefined(frameName)) {
    done = true;
  }

  while (!done) {
    //alert(parentObj.name+":"+parentObj.frames.length);

    for (i = 0; i < parentObj.frames.length; i++) {
      //alert(parentObj.frames[i].name);
      if (parentObj.frames[i].name == frameName) {
        done = true;
        frameObj = parentObj.frames[i];
        //alert("found toolbar frame");
        break;
      } else if (parentObj.frames[i].frames && parentObj.frames[i].frames.length > 0) {
        nextArray[nextArray.length] = parentObj.frames[i];
        //alert("added "+parentObj.frames[i].name+" to the next array");
      }
    }

    //alert("done with for loop with: "+j+":"+nextArray.length);
    if (!done && j < nextArray.length) {
      //alert("Making parent next: "+nextArray[j].name);
      parentObj = nextArray[j++];
      //alert(parentObj.name);
    }  else {
      //alert("gettin outta here!");
      done = true;
    }
  }
  return (frameObj);
}

function findFrameObjInOpener(frameName) {
  var i, j = 0;
  var parentObj = top.opener.top;
  var frameObj = null;
  var done = false;
  var nextArray = new Array();

  while (!done) {
    //alert(parentObj.name+":"+parentObj.frames.length);

    for (i = 0; i < parentObj.frames.length; i++) {
      //alert(parentObj.frames[i].name);
      if (parentObj.frames[i].name == frameName) {
        done = true;
        frameObj = parentObj.frames[i];
        //alert("found toolbar frame");
        break;
      } else if (parentObj.frames[i].frames && parentObj.frames[i].frames.length > 0) {
        nextArray[nextArray.length] = parentObj.frames[i];
        //alert("added "+parentObj.frames[i].name+" to the next array");
      }
    }

    //alert("done with for loop with: "+j+":"+nextArray.length);
    if (!done && j < nextArray.length) {
      //alert("Making parent next: "+nextArray[j].name);
      parentObj = nextArray[j++];
      //alert(parentObj.name);
    }  else {
      //alert("gettin outta here!");
      done = true;
    }
  }
  return (frameObj);
}

/*
 * Function to find and return a reference to the toolbar frame window object in 
 * a multi-framed environment. Use this function to get to the window that has
 * loaded toolbar.js so toolbar and toolbar button manipulation functions can
 * be found and used.
 */
function getToolBarFrame() {
  return (findFrameObj('toolbar'));
}

/*
 * Function to find and return a reference to the toolbar's content frame window 
 * object in a multi-framed environment.
 */
function getToolBarContentFrame() {
  return (findFrameObj('toolbar_content'));
}

/******************************************************************************
* End find frame window object functions.                                     *
******************************************************************************/
function textbox_onkeydown(field, enabled) {
  var allowEnter = enabled ? enabled : false;
  if (allowEnter) {
    var formName = null;
    if((window.event != null)&&(window.event.keyCode==13) ){
      formName = field.form.name;
    } else if ( arguments.callee.caller.arguments[0]!=null &&
                arguments.callee.caller.arguments[0].keyCode==13) {
      formName = field.form.name;
    }
    if (formName != null && document.forms[formName]) {
      //alert("Submitting: "+formName);
      document.forms[formName].submit();
      return false;
    } else {
      return true;
    }
  } else {
    if((window.event != null)&&(window.event.keyCode==13) ){
      return false;
    } else if ( arguments.callee.caller.arguments[0]!=null &&
        	arguments.callee.caller.arguments[0].keyCode==13) {
      return false;
    }
  }
}

/******************************************************************************
* Cookie functions.                                                           *
******************************************************************************/
function getCookie (sName) {
  //alert("getCookie: "+document.cookie);
  var re = new RegExp( "(\;|^)[^;]*(" + sName + ")\=([^;]*)(;|$)" );
  var res = re.exec(document.cookie);

  var res_temp = res != null ? res[3] : null;
  //alert("res_temp: " + res_temp);

  return res_temp;
}

function setCookie(sName, sValue, nDays) {
  var expires = "";
  //alert("nDays: " + nDays);
  if (nDays) {
    var d = new Date();
    d.setTime(d.getTime() + nDays * 24 * 60 * 60 * 1000);
    expires = "; expires=" + d.toGMTString();
    //alert("expire: "+expires);
  }
  document.cookie = sName + "=" + sValue + expires + "; path=/";
  //alert("setCookie: "+document.cookie);
}

function removeCookie (name) {
  setCookie(name, "", -1 );
}
/******************************************************************************
* End cookie functions.                                                       *
******************************************************************************/  

/******************************************************************************
* Functions to take window.location and extract out params portion of url     *
******************************************************************************/
function extractURIFromURL(url) {
  var tmpUrl = typeof(url) != "undefined" ? url : "";
  //alert("tmpUrl (before): "+tmpUrl);
  var i = tmpUrl.indexOf("\/\/");
  if (i > 0) {
    i = tmpUrl.indexOf("\/", i+2);
    if (i > 0) {
      tmpUrl = tmpUrl.slice(i, tmpUrl.length);
    }
  }
  //alert("tmpUrl (after): "+tmpUrl);
  return (tmpUrl);
}

function extractParamsFromUrl(window) {
  var url = new String(window.location);
  var i = url.indexOf("?");
  var params = null;
  if (i > 0) {
    params = new String(url.slice(i+1,url.length));
  }
  return (params);
}

function removeNameValuePair(paramsStr, name) {
  var returnStr = paramsStr;
  var tmp = new String(paramsStr);
  if (tmp != null && name != null) {
    var i = tmp.indexOf(name);
    if (i >= 0) {
      returnStr = new String (tmp.slice(0,i));
      var j = tmp.indexOf("&", i);
      if (j > 0) {
        returnStr += tmp.slice(j+1,tmp.length);
      }
    }
  } 
  return (returnStr);
} 
/******************************************************************************
* End window.location functions.                                              *
******************************************************************************/
function submitFormInAnotherFrameToTarget(frameName, form, href, targetPage) {
  //alert(frameName);
  eval("frameName.document."+form+".target=targetPage");
  eval("frameName.document."+form+".action=href");
	var fakebutton = eval("frameName.document." + form + ".fakesubmitbutton");
	if ( fakebutton ) fakebutton.click();
  else eval("frameName.document."+form+".submit()");
}

function relogin() {
  if (top.opener == null) {
    top.location='com.micromuse.common.htmlcomponents.servlets.NCLoginFramesServlet';
  } else {
    top.opener.top.location.href='com.micromuse.common.htmlcomponents.servlets.NCLoginFramesServlet'; top.close();
  }
}

/******************************************************************************
* Functions for javascript buttons embeded within page.                       *
******************************************************************************/
var buttonContainer = new NCButtonContainer();

function createJSForButtons() {
  //alert("createJSForButtons.......creating buttons array");
  var imgs = document.getElementsByTagName("img");
  //alert("Num of imgs: "+imgs.length);
  for (var i = 0; i < imgs.length; i++) {
    //alert(imgs.item(i).getAttribute("ncattribclass"));
    if (imgs.item(i).getAttribute("ncattribclass") != null && 
        imgs.item(i).getAttribute("ncattribclass") == "button") {
      var imgName = imgs.item(i).getAttribute("src");
      var j = imgName.lastIndexOf("/");
      var contextPath = imgName.slice(0, j);
      //alert(imgs.item(i).getAttribute("ncattribstate"));
      //alert(imgs.item(i).getAttribute("ncattribdisableimg"));
      buttonContainer.addButton(new NCButton(imgs.item(i).getAttribute("name"),
                                             imgs.item(i).getAttribute("src"),
                                             contextPath+"/"+
                                             imgs.item(i).getAttribute("ncattribdisableimg"),
                                             imgs.item(i).getAttribute("ncattribstate")));
    }
  }
}

// The var jsForButtonsEnabled is written by NCBasicPage so there
// is one per page.
function canDoNCButtonClick(name) {
  if (jsForButtonsEnabled && !isNCButtonEnabled(name)) {
    return false;
  }
  return true;
}

// Define a javascript button object.
function NCButton(name, icon, icon_disabled, state) {
  var enabledState = state ? state : "enabled";
  
  this.name = name ? name : "";

  // Very important to preload the images!
  // Lots of swapping of images based on state.
  // Must make sure they are all loaded!
  this.icon = new Image();
  this.icon.src =  icon ? icon : "";

  this.icon_disabled = new Image();
  if (name == "apply") {
    this.icon_disabled.src = "/netcool/images/button_cancel.png";
  } else {
    this.icon_disabled.src = icon_disabled ? icon_disabled : "";
  }

  this.enabled = (enabledState == "disabled") ? false : true;

  this.enableSelf = enableSelf;

  if (!this.enabled) {
    this.enableSelf(false);
  }
}

/*
 * Button sets self as enabled or disabled to keep track of state.
 */
function enableSelf(enable) {
  //alert("enablingSelf:\n"+this.name+" to "+enable);
  this.enabled = enable;
  swapImage(this.name, (this.enabled ? this.icon.src : this.icon_disabled.src));
} 
// End javascript button object.

// Define a button container object for an NCBasicPage. Button container is
// one per page.
function NCButtonContainer() {
  this.buttons = new Array();
  this.addButton = addButtonToContainer;
  this.findButton = findButtonInContainer;
}

/*
 * Function to add a button to a button container. Button container is one 
 * per NCBasicPage.
 */
function addButtonToContainer(button) {
  //alert("Adding button:\n"+button.name+"\n"+button.icon.src+"\n"+
  //       button.icon_disabled.src+"\n"+button.enabled);
  this.buttons[this.buttons.length] = button;
}

/*
 * Function to find and return a toolbar button
 * in the toolbar's array of buttons.
 */
function findButtonInContainer(name) {
  var i; 
  var button = null;
  
  for (i = 0; i < this.buttons.length; i++) {
    if (this.buttons[i].name == name) {
      button = this.buttons[i]; 
      break; 
    }
  }
  return (button);
}
// End javascript button object.

/*
 * Enable or disable a button in an NCBasicPage.
 * Note: Javascript variable buttonContainer is defined and set in page
 * by NCBasicPage.
 */
function enableNCButton(name, enable) {
  if (typeof(buttonContainer) != "undefined") {
    var button = buttonContainer.findButton(name);
    if (button) {
      button.enableSelf(enable);
    }
  }
}

/*
 * Returns enabled state for button in an NCBasicPage.
 * Note: Javascript variable buttonContainer is defined and set in page
 * by NCBasicPage.
 */
function isNCButtonEnabled(name) {
  if (typeof(buttonContainer) != "undefined") {
    var button = buttonContainer.findButton(name);
    if (button) {
      return (button.enabled);
    }
  }
  return ("undefined");
}
/******************************************************************************
* End functions for javascript buttons embeded within page.                   *
******************************************************************************/

/******************************************************************************
* Functions for javascript adding/removing NCDynamicTable rows.               *
******************************************************************************/
/**
 * Add a row to NCDynamicTable.
 * NOTE: This works with NCDynamicTable with or without deleteable turned on. It 
 * works with edit column if there is at least 1 row in the table
 * @param tablename a tablename, null or '' if none
 * @param datarow an array of text
 * @param isdeletable a boolean whether to include a checkbox column
 * @param deleteid delete ID
 * @param iseditable a boolean whether to include an edit column 
 */
 function addNCDynamicTableRow(tablename, datarow, isdeletable, deleteid, iseditable) {
	if ( !datarow || datarow.length == 0 ) return; // cannot empty rows
	if ( !tablename ) tablename = '';
	var tbody = document.getElementById(tablename + 'databody');
	var tritems = tbody.getElementsByTagName('tr');
	var row = tritems.length;
	var tr = document.createElement("TR");
	tr.setAttribute("id", "row" + row);
	if ( isdeletable ) {
		if ( !deleteid ) deleteid = row;
		var newinputcell = document.createElement("TD");
		var inputstr = (ie)?'<INPUT name="deleteUID">':'INPUT';
		var newcb = document.createElement(inputstr);
		newcb.setAttribute('name', 'deleteUID');
		newcb.type = 'CHECKBOX';
		newcb.value = deleteid;
		newcb.onclick = new Function("setSelectedRow(" + row + ");");
		newinputcell.setAttribute('align', 'center');
		newinputcell.className = 'TBLheader';
		newinputcell.appendChild(newcb);
		tr.appendChild(newinputcell);
	}
	var newcell;
	for ( a = 0; a < datarow.length; a++ ) {
		newcell = document.createElement("TD");
		newcell.setAttribute('style', 'overflow: hidden;');
		newcell.setAttribute('align', 'left');
		if ( (row)%2 == 1 ) tr.className = 'TBLaltRow';
		newcell.appendChild(document.createTextNode(datarow[a]));
		tr.appendChild(newcell);
	}
	if ( iseditable ) {
		if ( tritems.length > 0 ) {
			// we can only add this if there's 1 or more rows in the table
			var tditems = tritems[0].getElementsByTagName("TD");
			var neweditcell = null;
			for ( a = tditems.length - 1; a > 0; a-- ) {
				if ( tditems[a].innerHTML.indexOf('button_edit') != -1 ) {
					neweditcell = tditems[a].cloneNode(true); 
					break;
				}
			}
			if ( neweditcell ) {
				var edithtml = neweditcell.innerHTML;
				edithtml = edithtml.replace(/editCurrentRow\(\'\d+\'\)/g, 'editCurrentRow(\'' + row + '\')');
				edithtml = edithtml.replace(/\'e\d+\'/g, '\'e' + row + '\'');
				edithtml = edithtml.replace(/\"e\d+\"/g, '"e' + row + '"');
				neweditcell.innerHTML = edithtml;
				tr.appendChild(neweditcell);
			}
		}
	}
	var newcell;
	for ( a = 0; a < datarow; a++ ) {
		newcell = document.createElement("TD");
		newcell.setAttribute('style', 'overflow: hidden;');
		newcell.setAttribute('align', 'left');
		if ( (row)%2 == 1 ) tr.className = 'TBLaltRow';
		newcell.appendChild(document.createTextNode(datarow[a]));
		tr.appendChild(newcell);
	}
	tbody.appendChild(tr);
	setSelectedRow(row, true);
}

/**
 * Delete selected rows from NCDynamicTable.
 * NOTE: This won't work with no edit column and/or move column
 * @return a list of deleted rows' deleteUID separated with comma's.
 */
function deleteNCDynamicTableRows() {
	var uids = '';
	var delobj = document.mainForm.deleteUID;
	var tbody = document.getElementById('databody');
	var tritems = tbody.getElementsByTagName('tr');
	if ( delobj.length ) {
		var cblength = delobj.length;
		var initrow = false;
		var j = 0;
		for ( i = 0; i < delobj.length; i++ ) {
			selectedIDs[j++] = null;
			if ( delobj[i].checked ) {
				if ( (i+1) < tritems.length ) {
					tritems[(i+1)].className = (i%2)?'TBLaltRow':'';
				}
				if ( tritems[i] ) {
					uids = uids + delobj[i].value + ',';
					tbody.removeChild(tritems[i]);
				} else break;
				i--;
				initrow = true;
				continue;
			}
			if ( initrow ) {
				tritems[i].id = 'row' + i;
				setSelectedRow(i, true);
				delobj[i].onclick=new Function('setSelectedRow(' + i + ');');
			}
		} 
		if ( uids.length > 1 ) {
			uids = uids.substring(0, uids.length-1);
		}
	} else if ( delobj.checked ) { 
		selectedIDs[0] = null;
		uids = delobj.value;
		tbody.removeChild(tritems[0]);
	} 
	return uids;
}
/******************************************************************************
* End functions for javascript adding/removing NCDynamicTable rows            *
******************************************************************************/

/****************************************************************************
* Functions for use by applcations that are content of dynamic tabpanes.    *
*****************************************************************************/
// Function to tell dynamic tabpane save is in progress.
function notifyTabPaneSaveInProgress(tabpaneFrameName) {
  var tabpaneFrameObj = findFrameObj(tabpaneFrameName);
  if (tabpaneFrameObj != null) {
    tabpaneFrameObj.notifySaveInProgress();
  }
}

// Function to query tabpane to see if save is in progress.
function isTabPaneSaveInProgress(tabpaneFrameName) {
  var tabpaneFrameObj = findFrameObj(tabpaneFrameName);
  if (tabpaneFrameObj != null) {
    return (tabpaneFrameObj.isSaveInProgress());
  }
  return (false);
}

// Function to have dynamic tabpane to store application specific data.
//
// tabpaneName - name of dynamic tabpane application belongs to
// key - unique key to store data under
// value - data to store
function storeDataForTabPaneApplication(tabpaneName, key, data) {
  var tabpaneFrameObj = findFrameObj(tabpaneName);
  if (tabpaneFrameObj != null) {
    tabpaneFrameObj.storeDataInCache(key, data);
  }
}

// Function to have dynamic tabpane to store application specific data.
// Returns data if item with key exists, otherwise null.
//
// tabpaneName - name of dynamic tabpane application belongs to
// key - unique key to store data under
function retrieveDataForTabPaneApplication(tabpaneName, key) {
  var tabpaneFrameObj = findFrameObj(tabpaneName);
  if (tabpaneFrameObj != null) {
    var dataObj = tabpaneFrameObj.retrieveDataFromCache(key);
    if (dataObj != null) {
      return (dataObj.value);
    }
  }
  return (null);
}

// Function to iterate through all frames of current page looking dynamic 
// tabpanes and calling their tabChangeHandlers.
// The tabChangeHandlers are application defined and can alert user of
// whatever application defines on a tabChange.  A tabChange includes, the
// user clicking on a different tab, the user closing a tab or the user 
// adding a new tab.  This function provides a mechanism to call existing
// tabChangeHandlers for all dynamic tabbedpanes found.  This may be useful
// for instance on a page reload.
var tabChangeIsOk = true;
function dynamicTabChangeHandlersOk(parent) {
  var parentObj;
  if (isDefined(parent)) {
    parentObj = parent;
  } else {
    parentObj = top;
    tabChangeIsOk = true;
  }
  //alert("parentObj: "+parentObj+":"+parentObj.frames.length);
  if (!tabChangeIsOk) {
    return (false);
  }
  for (var i = 0; i < parentObj.frames.length && tabChangeIsOk; i++) {
    //alert(parentObj.frames[i].name);
    if (isDefined(parentObj.frames[i].tabChangeHandler)) {
      //alert("Found tabChangeHandler for: "+parentObj.frames[i].name);
      tabChangeIsOk = parentObj.frames[i].tabChangeHandler();
    }
    tabChangeIsOk = dynamicTabChangeHandlersOk(parentObj.frames[i]);
  }
  return (tabChangeIsOk);
}
/********************************************************************************
* End functions for use by applcations that are content of dynamic tabpanes.    *
*********************************************************************************/

/****************************************************************************
* Functions for navigation toggle button.                                   *
*****************************************************************************/
// Function to handle onClickEvent of navigation button. Return true
// to allow navigation panel toggle and false otherwise.
function canDoNavigationToggle() {
  // For once IE handles a javascript problem better than NS.
  // If this is IE resizing frames does not cause them to unload,
  // so no data is lost that user may have entered on page. If,
  // however this is NS, call the tabChangeHandlers for each
  // dynamicTabPane, if they exist, so user is at least warned.
  if (!ie && !dynamicTabChangeHandlersOk()) {
    return (false);
  }
  return (true);
}

// Function to handle onLoad event of navigation button frame. If 
// browser is NS, it will reload frames, we must handle this so
// correct navigation button is showing (e.g. open vs close button).
function onLoadNavigationButtonFrame(framesetId, navImgName, imgPath) {
  var fsId = isDefined(framesetId) ? framesetId : "nav_frame";
  var imagePath = isDefined(imgPath) ? imgPath : "/netcool/images/";
  var framesetObj = parent.document.getElementById(fsId);
  if (!ie && framesetObj != null) {
    var showCols = framesetObj.getAttribute("show_cols");
    var hideCols = framesetObj.getAttribute("hide_cols");
    var showRows = framesetObj.getAttribute("show_rows");
    var hideRows = framesetObj.getAttribute("hide_rows");
    var navState = getCookie(fsId+"_navState");
    var isHidden = (isDefined(navState) && navState == "0") ? true : false;
    if (isHidden && (hideCols != null) && (framesetObj.cols == hideCols)) {
      if (isDefined(navImgName)) {
        swapImage(navImgName, imagePath+"icon_open_navigation.png");
      }
    }
  }
}

function toggleNavigationFrame(framesetId, navImgName, imgPath) {
  var fsId = isDefined(framesetId) ? framesetId : "nav_frame";
  var imagePath = isDefined(imgPath) ? imgPath : "/netcool/images/";
  var framesetObj = parent.document.getElementById(fsId);
  if (framesetObj != null) {
    var showCols = framesetObj.getAttribute("show_cols");
    var hideCols = framesetObj.getAttribute("hide_cols");
    var showRows = framesetObj.getAttribute("show_rows");
    var hideRows = framesetObj.getAttribute("hide_rows");
    //alert("showCols:hideCols "+showCols+":"+hideCols);
    //alert("showRows:hideRows "+showRows+":"+hideRows);
    //alert("currentCols: "+framesetObj.cols);
    if (hideCols != null && showCols != null) {
      if (framesetObj.cols == hideCols) {
        //alert("showing nav frames");
        if (isDefined(navImgName)) {
          swapImage(navImgName, imagePath+"icon_close_navigation.png");
        }
        setCookie(fsId+"_navState", "1");
        framesetObj.setAttribute("cols", showCols);
      } else {
        //alert("hiding nav frames");
        if (isDefined(navImgName)) {
          swapImage(navImgName, imagePath+"icon_open_navigation.png");
        }
        setCookie(fsId+"_navState", "0");
        framesetObj.setAttribute("cols", hideCols);
      }
    }
    if (hideRows != null && showRows != null) {
      if (framesetObj.rows == hideRows) {
        //alert("showing nav frames");
        if (isDefined(navImgName)) {
          swapImage(navImgName, imagePath+"icon_close_navigation.png");
        }
        setCookie(fsId+"_navState", "1");
        framesetObj.setAttribute("rows", showRows);
      } else {
        //alert("hiding nav frames");
        if (isDefined(navImgName)) {
          swapImage(navImgName, imagePath+"icon_open_navigation.png");
        }
        setCookie(fsId+"_navState", "0");
        framesetObj.setAttribute("rows", hideRows);
      }
    }
  } else {
    alert("Cannot toggle navigation panel. No framesetObj found!");
  }
}
/****************************************************************************
* End functions for navigation toggle button.                               *
*****************************************************************************/

/****************************************************************************
* Functions for logobar service navigation list.                            *
* Note: Vars currApp, selectedUrl, idToSelect and mainFrameObj are global   *
* to page.                                                                  * 
*****************************************************************************/
function onLoadNCLogoBar() {
  currApp = getCookie('ncCurrApp');
  //alert("begin cookie: "+currApp);
  //alert("begin idToSelect: "+idToSelect);
  var serviceSelect = null;
  var serviceList = null;
  var selects = document.getElementsByTagName("select");
  for (var i = 0; i < selects.length; i++) {
    if (selects.item(i).getAttribute("name") != null &&
        selects.item(i).getAttribute("name") == "logoBarServiceNav") {
      serviceSelect = selects.item(i);
      serviceList = serviceSelect.options;
      break;
    }
  }
  if (serviceList != null) {
    if (currApp != null && currApp > -1) { 
      if (currApp < serviceList.length) {
        selectedUrl = serviceList[currApp].value; 
        //alert("1 selectedUrl: "+selectedUrl);
        serviceSelect.selectedIndex = currApp;
        //alert("1 selectedIndex: "+serviceSelect.selectedIndex);
      } else {
        removeCookie('ncCurrApp');
      }
    } else if (isDefined(idToSelect)) {
      setCookie('ncCurrApp', idToSelect);
      if (idToSelect > -1) {
        selectedUrl = serviceList[idToSelect].value;
        //alert("2 selectedUrl: "+selectedUrl);
        serviceSelect.selectedIndex = idToSelect;
        //alert("2 selectedIndex: "+serviceSelect.selectedIndex);
      }
    }
  }
  if (isDefined(mainFrameObj) && selectedUrl != null) {
    var mainFrameUrl = extractURIFromURL(mainFrameObj.location.href);
    selectedUrl = extractURIFromURL(selectedUrl);
    if (mainFrameUrl != selectedUrl) { 
      mainFrameObj.location.href = selectedUrl;
    }
  }
}

// Note: the first item in the services navigation list is "Please Select".
function onChangeNCLogoBarNavigationList(serviceSelect) {
  if (isDefined(serviceSelect)) {
    removeCookie('ncCurrApp');
    var selected = serviceSelect.selectedIndex;
    if (selected == -1) {
      // "Please select" will always be 1st item in services list.
      selected = 0;
    }
    setCookie('ncCurrApp', selected);
    var selectedUrl = null;
    if (selected < serviceSelect.length) {
      selectedUrl = serviceSelect.options[selected].value;
    }
    if (isDefined(mainFrameObj) && selectedUrl != null) {
      var mainFrameUrl = extractURIFromURL(mainFrameObj.location.href);
      selectedUrl = extractURIFromURL(selectedUrl);
      if (mainFrameUrl != selectedUrl) {
        mainFrameObj.location.href = selectedUrl;
      }
    }
  }
}
/****************************************************************************
* End functions for logobar service navigation list.                        *
*****************************************************************************/
