/******************************************************* {COPYRIGHT-TOP-OCO} ***
 * Licensed Materials - Property of IBM
 *
 * 5724-C51
 *
 * (C) Copyright IBM Corp. 2007 All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication, or
 * disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 ******************************************************* {COPYRIGHT-END-OCO} ***/
/*******************************************************************************
 * CMVC Location: radCommonInstallBase/guifoundation/webapps/sla/netcool/scripts/script.js, tbsm_rad, tbsm_rad_3.0
 * Version:       1.2
 * Last Modified: 07/04/09 13:17:35
 *******************************************************************************/


/*****************************************************************************
* BEGIN common library of general usefulness                                 *
******************************************************************************/
// Browser variables
var w3c=(document.getElementById)? true: false;
var ie=(w3c && document.all)? true : false;
var ns=(w3c && (navigator.appName=="Netscape"))? true : false;

// Characters that are illegal for data type names.
var illegalChars = "' \" ! $ % <space> <tab> / \\";

// 
// Append text from select list box to a textfield or 
// textarea
// @param listbox list box object
// @param toField text field or text area object
//
function listBoxToTextField(listbox, toField) {
	if ( !listbox || !toField ) return;
	var txt = listbox.options[listbox.selectedIndex].value;
	if ( !toField.value ) toField.value = txt;
	else toField.value = toField.value + txt;
}

//
// Select All checkboxes. TR id must be clientId appended with _
// and row index
// @param sel select object
// @param checked a boolean whether to select all or unselect all
// @param clientId clientId to get the TR element for setting the
// selectedClass
// @param selectedClass css class to set when the row is selected. 
// Set to null if not using
//
function selectAll(sel, checked, clientId, selectedClass) {
	if ( !sel ) {
		alert('selectAll error: select object is null.');
		return;
	}
	var trObj = null;
	if ( sel.length ) {
		// multiple checkboxes
  	for (i = 0; i < sel.length; i++) {
   		sel[i].checked = checked;
			if ( clientId && selectedClass && selectedClass != '' ) {
				trObj = document.getElementById(clientId + '_' + i);
				if ( trObj ) {
					highlightRow(trObj, selectedClass, checked);
				}
			}
		}
	} else {
		// one checkbox
   	sel.checked = checked;
		if ( clientId && selectedClass && selectedClass != '' ) {
			trObj = document.getElementById(clientId + '_0');
			if ( trObj ) {
				highlightRow(trObj, selectedClass, checked);
			}
		}
	}
}

//
// highlight a row with the specified css class name
// @param trObj tr object
// @param className css class name
// @param checked a boolean whether the row is selected
//
function highlightRow(trObj, className, checked) {
	if ( trObj == null ) return;
	if ( !className || className == 'null' || className == '' ) return;
	var oldcss = trObj.oldClass;
	if ( !checked && oldcss && oldcss != '' ) {
		trObj.className = oldcss;
	} else if ( checked ) { 
		// only save class name if it's not the same as the old one
		if ( trObj.className != className ) {
			trObj.oldClass = trObj.className;
			if ( !trObj.oldClass || trObj.oldClass == '' ) {
				trObj.oldClass = 'none';
			}
		}
		trObj.className = className;
	}
}

function highlightOneRow(currentTRObj, tblObj, className, nocleanup, unselect) {
	if ( unselect ) {
		highlightRow(currentTRObj, className, false);
		currentTRObj.highlight = false;
	} else {
		highlightRow(currentTRObj, className, true);
		currentTRObj.highlight = true;
	}
 	document.getElementById(currentTRObj.getAttribute('rowFormId')).value = unselect?'false':'true';

	// unselect others
	var trObjs = tblObj.getElementsByTagName('tr');
	if ( trObjs && !nocleanup ) {
		var rowForm = null;
		for ( i = 0; i < trObjs.length; i++ ) {
			if ( trObjs[i].getAttribute('rowIndex') == currentTRObj.getAttribute('rowIndex') ) {
				continue;
			}
			highlightRow(trObjs[i], className, false);
			trObjs[i].highlight = false;
			rowForm = document.getElementById(trObjs[i].getAttribute('rowFormId'));
			if ( rowForm ) {
				rowForm.value = 'false';
			}
		}
	}
}

var tblCurrentKeyDownCtrl = false;
var tblCurrentKeyDownShift = false;
function initMultipleSelectTable() {
	if ( ie ) {
 		document.body.attachEvent("onkeyup", setTableKeyPressed);
 		document.body.attachEvent("onkeydown", setTableKeyPressed);
	} else {
 		document.addEventListener("keyup", setTableKeyPressed, true);
 		document.addEventListener("keydown", setTableKeyPressed, true);
	}
}

function setTableKeyPressed(event) {
	tblCurrentKeyDownCtrl = event.ctrlKey;	
	tblCurrentKeyDownShift = event.shiftKey;	
}

function highlightMultipleRow(currentTRObj, tblObj, className) {
	if ( tblCurrentKeyDownCtrl || tblCurrentKeyDownShift ) {
		if ( tblCurrentKeyDownCtrl ) {
			// ctrl key pressed
			var unselect = false;
			if ( currentTRObj.highlight ) {
				unselect = true;
			}
			highlightOneRow(currentTRObj, tblObj, className, true, unselect);
		} else if ( tblCurrentKeyDownShift ) {
			// shift key pressed
			highlightOneRow(currentTRObj, tblObj, className, false);
			var trObjs = tblObj.getElementsByTagName('tr');
			var currentIndex = parseInt(currentTRObj.rowIndex);
			// we have to minus 1 for Netscape/Mozilla to work here
			if ( ns ) currentIndex --;
			if ( !tblObj.lastSelectedRow ) 
				tblObj.lastSelectedRow = currentIndex;
			var startIndex = currentIndex;
			var endIndex = parseInt(tblObj.lastSelectedRow) + 1;
			if ( currentIndex > parseInt(tblObj.lastSelectedRow) ) {
				startIndex = parseInt(tblObj.lastSelectedRow);
				endIndex = currentIndex + 1;
			} else if ( currentIndex == parseInt(tblObj.lastSelectedRow) ) {
				startIndex = currentIndex;
				endIndex = currentIndex + 1;
			}
			for ( i = startIndex; i < endIndex; i++ ) {
				highlightOneRow(trObjs[i], tblObj, className, true);
			}
		}
	} else {
		highlightOneRow(currentTRObj, tblObj, className, false);
	}
	// sets the last selected row 
	// for some reason, Netscape/Mozilla increments the number by 1
	// we have to minus 1 for this to work
	tblObj.lastSelectedRow = ns?currentTRObj.rowIndex-1:currentTRObj.rowIndex;
}

// Sort select options
// @param obj select object
function sortSelect(obj) {
	var o = new Array();
	if (obj.options==null) { return; }
	for (var i=0; i<obj.options.length; i++) {
		o[o.length] = new Option( obj.options[i].text, obj.options[i].value, obj.options[i].defaultSelected, obj.options[i].selected) ;
	}
	if (o.length==0) { return; }
	o = o.sort( 
		function(a,b) { 
			if ((a.text+"") < (b.text+"")) { return -1; }
			if ((a.text+"") > (b.text+"")) { return 1; }
			return 0;
		} 
	);

	for (var i=0; i<o.length; i++) {
		obj.options[i] = new Option(o[i].text, o[i].value, o[i].defaultSelected, o[i].selected);
	}
}

function swapImage(img_name, img_src ) {
	if ( !img_name ) return;
  eval("document."+img_name+".src=img_src");
}

function submitForm(form, href) {
	eval("document."+form+".action=href");
	var fakebutton = eval("document." + form + ".fakesubmitbutton");
	if ( fakebutton ) fakebutton.click();
	else eval("document."+form+".submit()");
}

function submitFormToTarget(form, href, targetPage) {
  eval("document."+form+".target=targetPage");
  eval("document."+form+".action=href");
	var fakebutton = eval("document." + form + ".fakesubmitbutton");
	if ( fakebutton ) fakebutton.click();
  else eval("document."+form+".submit()");
}

function changeNumberValue(name, increase, min, max, unit) {
  var temp = parseInt(name.value);
  if(increase) {
    temp+=unit;
  } else {
    temp-=unit;
  }
  if(!verifyRange(min, max, temp)){
    return;
  }
  name.value=temp;
}

function verifySpinnerKeyDown(event, spinnerInput, decimal, sign) {
	var keyCode = event.which;
	var tabCode = 0;
	if ( ie ) {
		keyCode = event.keyCode;
		tabCode = 9;
	}

  if ( sign ) {
    if ( keyCode == 43 || keyCode == 45 ) {
      // we keep spinner's old value
      if ( spinnerInput ) 
        spinnerInput.oldValue = spinnerInput.value;
      // don't know how to get the current key position. It has
      // to verify the number in the backend or some other way.
      // Return true for now so that we can have +/-
      return true;
    }
  }
	if ( keyCode == 8 || keyCode == tabCode ||
			 (keyCode > 36 && keyCode < 41) ||
			(keyCode > 47 && keyCode < 58) ) {
    // we keep spinner's old value
    if ( spinnerInput ) 
      spinnerInput.oldValue = spinnerInput.value;
		return true; 
	} else if ( decimal && (keyCode == 190 || keyCode == 46) ) {
    // we keep spinner's old value
    if ( spinnerInput ) 
      spinnerInput.oldValue = spinnerInput.value;
		return true;
	} else {
		return false;
	}
}

//
// Block white space in text field
// @event onKeyPress event
// @return a boolean whether the current keypress is a spacebar
//
function blockWhiteSpaceInTextField(event) {
	var keys = new Array();
	keys[0] = 32; // spacebar
	return blockKeysOnKeyPress(event, keys, false);
}

//
// Block the specified keys in the text field
// @event the key event
// @keys browser keycode in an array of int
// @allowTab a boolean whether tab is allowed. Default: false
// @return a boolean whether the current keypress is allowed
//
function blockKeysOnKeyPress(event, keys, allowTab) {
	var keyCode = event.which;
	var tabCode = 0;
	if ( ie ) {
		keyCode = event.keyCode;
		tabCode = 9;
	}
	if ( keyCode == tabCode && !allowTab ) return false;
	else {
		for ( k = 0; k < keys.length; k++ ) {
			if ( keyCode == keys[k] ) return false;
		}
	}
	return true;
}

function changeSpinnerNumberValue(name, increase, min, max, unit, decimal) {
  
	if ( !name.value || (name.value == '') ) {
		name.value = 0;
    name.focus();
		return;
  } else if(!isInputNumber(name.value,true, decimal)) {
    alert(name.value+' is not a number!');
    name.focus();
    name.select();
    return;
  }
 //alert('changeNumberValue is called '+name+' increase '+increase+'min '+min+' max '+max+' unit '+unit+' decimal '+decimal); 
   var temp = name.value;
    if(decimal) {
   temp = parseFloat(name.value);
   unit = parseFloat(unit);
   min = parseFloat(min);
   max = parseFloat(max);
  } else {
   temp = parseInt(name.value);
   unit = parseInt(unit);
   min = parseInt(min);
   max = parseInt(max);
 }
  //alert(' min is '+min+ ' max '+max+'unit '+unit);
  if(increase) {
    temp += unit;
  } else {
    temp -= unit;
  }  
  if(min != null && temp < min) {
   alert(' value should be no less than '+min);
   name.focus();
   name.select();
    return;
  } else if (max != null && temp > max) {
   alert(' value should be no more than '+max);
   name.focus();
   name.select();
    return;
 }
  name.value=temp;
}

function increaseNumber(name) {
  var origValue = name.value;
  var temp = parseInt(name.value);
  temp++;
  name.value=temp;
}

function closeWindow(windowName) {
  window.close();
}
function containsSpace(string) {
  for(var i=0; i<string.length; i++) {
    if(string.charAt(i) == ' ') {
      alert('Spaces are not allowed. You may use characters such as underscores or hypens to indicate spaces.');
      return true;
    }
  }
  return false;
}
function isInteger(val) {
	for(var i=0; i<val.length;i++) {
	   if(!isDigit(val.charAt(i))) {
	      		return false;
            }
	}
	return true;
}

function isDigit(num) {
	var string="1234567890";
	if (string.indexOf(num) != -1) {
	   return true;
	}
	return false;
}

function getRandom() {
  return (Math.random());
}

function nctrim(inputobj) {
   inputobj.value=trim(inputobj.value);
}

function trim(input) {
  var retval = "";
  var counter = 0;
  var counter2 = input.length - 1;
  var ch = input.charAt(counter);

  if(input == null || input.length < 1)
    return retval;

  // strip beginning
  while(counter < input.length &&
   (ch == ' ' || ch == '\n' || ch == '\t' || ch == '\r') ) {
  counter++;
  ch = input.charAt(counter);
  }

  // strip end
  ch = input.charAt(counter2);

  while(counter2 > -1 &&
   (ch == ' ' || ch == '\n' || ch == '\t' || ch == '\r') ) {
  counter2--;
  ch = input.charAt(counter2);
  }

  if(counter > counter2) return retval;

  for( ; counter != (counter2 + 1); counter++) {
  retval += input.charAt(counter);
  }

  return retval;

} // endfunc trim


// Check if input is digits including decimal and sign
// if the sign boolean is true
// @param input the input text
// @param sign true, to allow sign numbers
// @param decimal true, to allow decimal 
// @return true if input is all digits 
function isInputNumber(input, sign, decimal) {
  if(input.length == 0) return false;  
  var numbers = "0123456789";
	if ( decimal ) numbers = numbers+".";
  if ( sign ) numbers = numbers+"-";
  for(var i=0; i < input.length; i++) {        
    if(numbers.indexOf(input.charAt(i)) < 0) {                          
      return false;
    }                                                                   
  }                                                                     
                                                                             
  return true;   
} // endfunc isInputNumber

// check for empty input condition
// @param input  input to be checked for empty condition
// @return true if input is empty or all whitespace, false otherwise
function isBlank(input) {

  for(var i=0; i < input.length; i++) {
    var ch = input.charAt(i);
    if( ch!=' ' && ch!='\n' && ch!='\t' && ch!='\r' ) {
      return false;
    }
  }

  return true;

} // endfunc isBlank

// checks to see if input actully is defined and is not
// null - can use to determine if input params are defined
function isDefined(input) {
  if (typeof(input) == "undefined" || input == null) {
    return (false);
  }
  return (true);
}

// checks to see if input is digits only
// @param input  Check this var to see if it contains all digits
// @return true if input is numerical ( >=0, no decimals, signs)
function isNumber(input) {

  if(input.length == 0) return false;

  var numbers = "0123456789";
  for(var i=0; i < input.length; i++) {
    if(numbers.indexOf(input.charAt(i)) < 0) {
      return false;
    }
  }

  return true;

} // endfunc isNumber

// checks to see if input is digits only
// @param input  Check this var to see if it contains all digits
// @return true if input is numerical ( >=0, no decimals, signs)
function isAlphaNumeric(input) {

  if(input.length == 0) return false;

  var ch;

  for(var i=0; i < input.length; i++) {

    ch = input.charAt(i);

    if( !(ch >= 'a' && ch <= 'z' ||
          ch >= 'A' && ch <= 'Z' ||
          ch >= '0' && ch <= '9' ||
          ch == ' ' ) ) {
          return false;
    } // endif
  } // endfor

  return true;

} // endfunc isAlphaNumeric

// containsIllegalChars
// Checks to see if input doesn't contain an illegal chars
// as defined by illegalChars = "'\"!$%<space><tab>/\\";
// @param input  Check this var to see if it contains any invalid char.
// @return true if input is bad char free. 
function containsIllegalChars(input) {
  if(containsSpace(input)) {
    return true;
  }
  var ch;
  
  for(var i = 0; i < input.length; i++) {

    ch = input.charAt(i);
    
    if (ch == '\'' ||
	ch == '\"' ||
	ch == '!' ||
        ch == '$' ||
        ch == '%' ||
        ch == '/' ||
        ch == '\\' ) {
      
      alert('Special character '+ch+ ' not allowed.');
      return true;
    } // endif	
  } // endfor	

  return false;

} // endfun containsIllegalChars



// @param min   Minimum number in range, inclusive
// @param max   Maximum number in range, inclusive
// @param input Check this number to see if in between min and max
// @return true if range of input is in between the min/max inclusive
function verifyRange(min, max, input) {

  if( (input < min) || (input > max) ) return false;
  else return true;

} // endfunc verifyRange

//validate the passed string parameter is a vaildate email address
function isValidEmail(strEmail) {
  validRegExp =/^[^@]+@[^@]+.[a-z]{2,}$/i;
  if(strEmail.search(validRegExp) == -1) {
    alert('A valid e-mail address is required.\nPlease enter a validate one');
    return false;
  }
  return true;
}

// counts number of options in a Select object that have been selected
// @param selectobj  SELECT object with OPTIONs
// @return number of items selected in list
function countSelections(selectobj) {

  var select_counter = 0;

  for(var i = 0; i < selectobj.options.length; i++) {
    if(selectobj.options[i].selected) select_counter++;
  }

  return select_counter;

} // endfunc countSelections




// checks to see if string item is not already contained within a
// Select object's list item, either as a substring, or an entire match
// @param item    The item string to be searched for in Select list
// @param selobj  The Select object
// @param exact  true if whole item should match, false if substring
// @return      index of option found, or -1 if not found
function findItemInList(item, selobj, exact) {

  if(!exact) {
    for(var i = 0; i < selobj.options.length; i++)
      if( selobj.options[i].text.indexOf(item) != -1 )
        return i; // item found
  }
  else for(var i = 0; i < selobj.options.length; i++)
    if( selobj.options[i].text == item)
      return i; // exact match found

  return -1;   // item was not found

} // endfunc findItemInList

/*
 * Returns true if element is an input control of type checkbox.
 */
function isCheckBox(element) {
  if (typeof(element.getAttribute("type")) != "undefined") {
    if (element.getAttribute("type") == "CHECKBOX" ||
        element.getAttribute("type") == "checkbox") {
      //alert("Found checkbox");
      return (true);
    }
  }
  return (false);
}

/*
 * Returns true if element is an input control that can be checked.
 */
function isCheckableElement(element) {
  if (typeof(element.getAttribute("type")) != "undefined") {
    if (element.getAttribute("type") == "CHECKBOX" ||
        element.getAttribute("type") == "checkbox" ||
        element.getAttribute("type") == "RADIO" ||
        element.getAttribute("type") == "radio") {
      //alert("Found checkable element.");
      return (true);
    }
  }
  return (false);
}

/*
 * Returns request params string creataed from a form elements array. Returns
 * an empty string if formElements is null or does not contain any elements.
 */

function getRequestParamsStr(formElements, leaveOffQuestionMark) {
  var paramsList = new String("");
  var regExp = /\+/g;
  var regExp2 = /\&/g;
  var regExp3 = /\#/g;
  if (formElements != null) {
    for (var i = 0; i < formElements.length; i++) {
      if (!isCheckableElement(formElements[i]) ||
          (isCheckableElement(formElements[i]) && formElements[i].checked)) {
        var temp = encodeURI(formElements[i].value);
	temp = temp.replace(regExp, "%2B");
	temp = temp.replace(regExp2, "%26");
	temp = temp.replace(regExp3, "%23");

        if (i == 0) {
          if (leaveOffQuestionMark) {
            paramsList = encodeURI(formElements[i].name)+"="+temp;
          } else {
            paramsList = "?"+encodeURI(formElements[i].name)+"="+temp;
          }
        } else {
          paramsList += "&"+encodeURI(formElements[i].name)+"="+temp;
        }
      }
    }
  }
  return (paramsList);
}


/**
 * Get the coordinates of the center of the screen. Use this
 * to center the new window on the screen
 * @param width width of the new window
 * @param height height of the new window
 * @return the center coordinates in an array - first element is x
 * and second element is y
 */
function getCenterCoordinates(width, height) {
	var x = (screen.width/2) - (width/2);
	var y = (screen.height/2) - (height/2);

	return new Array(x, y);
}

//-- START: Form Check
/**
 * Check the required fields 
 * @param fieldRequired an array of required fields
 * @param fieldDescription an array of required field description
 */
var saveformbgcolor = Array();
function validateRequiredFields(formobj, fieldRequired, fieldDescription) {
	// dialog message
	var alertMsg = "Please complete the following fields:\n";
	var warningcolor = "#FF0000";
	var l_Msg = alertMsg.length;
	var count = 0;
	
	for (var i = 0; i < fieldRequired.length; i++) {
		var obj = formobj.elements[fieldRequired[i]];
		if (obj) {
			if ( !saveformbgcolor[fieldRequired[i]] ) {
				if ( obj.style.background && obj.style.background != '' )
					saveformbgcolor[fieldRequired[i]] = obj.style.backgroundColor;
				else
					saveformbgcolor[fieldRequired[i]] = '#FFFFFF';
			}
			obj.style.backgroundColor = saveformbgcolor[fieldRequired[i]];
			switch(obj.type){
			case "select-one":
				if (obj.selectedIndex == -1 || obj.options[obj.selectedIndex].text == "" || 
					  obj.options[obj.selectedIndex].text == "Choose One" ||
						obj.options[obj.selectedIndex].text == "Please Select" ) {
					obj.style.backgroundColor=warningcolor;
					alertMsg += " - " + fieldDescription[i] + "\n";
					count++;
				}
				break;
			case "select-multiple":
				if (obj.selectedIndex == -1) {
					alertMsg += " - " + fieldDescription[i] + "\n";
					obj.style.backgroundColor=warningcolor;
					count++;
				}
				break;
			case "text":
			case "textarea":
				if (obj.value == "" || obj.value == null) {
					obj.style.backgroundColor=warningcolor;
					alertMsg += " - " + fieldDescription[i] + "\n";
					count++;
				} else if ( (obj.fieldtype == 'int') && 
								(isInputNumber(obj.value)) ) {
					obj.style.backgroundColor=warningcolor;
					alertMsg += " - " + fieldDescription[i] + ". *It must be an integer.*\n";
					count++;
				}
				break;
			default:
			}
			if (obj.type == undefined) {
				var blnchecked = false;
				for (var j = 0; j < obj.length; j++) {
					if (obj[j].checked) {
						blnchecked = true;
					}
				}
				if (!blnchecked) {
					alertMsg += " - " + fieldDescription[i] + "\n";
					count++;
				}
			}
		}
	}

	if (alertMsg.length == l_Msg) {
		return true;
	} else {
		alertMsg = alertMsg.substring(0, alertMsg.length - 1);
		if ( window.popup_DOMWindow_text ) {
			alertMsg = alertMsg + '<br><br><center><a href="javascript:hidebox(\'errorcid\')" onClick="hidebox(\'errorcid\');" class="menuNav"><img border="0" src="/netcool/images/button_close.png"></a></center>';
			popup_DOMWindow_text('errorcid', alertMsg, 'Error: Required fields not completed', 300, Math.max((count*55)+40, 120)); 
		} else alert(alertMsg); 
		return false;
	}
}

function makeFormViewOnly(errorMsg) {
  if (errorMsg != null) {
    alert(errorMsg);
  }
  for (i=0; i<document.mainForm.elements.length; i++) {
    document.mainForm.elements[i].disabled=true;
  }
}

// 
//
// This function checks the variable requiredFields array for the element ID
// to check whether there is a value. The variable "satisfied" will be true
// if all required fields were filled in.
// NOTE: if the required field element is hidden, it's considered as 
// required met. This means the variable satisfied is true
// If the variable requiredFieldsEvalJS array
// is not null, this function will eval the JS found in this variable 
// instead of checking the element value. The JavaScript MUST return a boolean. 
// If the variable requiredFieldsExecJS is not null, after eval or checking the 
// element value, this function will execute the Javascript.
// This function should be called in the onKeyUp action
// @param buttonName button name to disable. For disabling multiple buttons,
// use comma as the separator. Set to null if not disabling button
// @param requiredFields - an array of element id's to check
// @param requiredFieldsEvalJS - an array of javascript to eval for verifying
// @param requiredFieldsExecJS - javascript to exec after verification of 
// required fields. A variable "satisfied" will return true if all required
// fields were entered, false otherwise
// @param params additional parameters. Not sure what good this will do but
// it might be useful when executing eval ??
function verifyRequiredFields(buttonName, requiredFields, requiredFieldsEvalJS, requiredFieldsExecJS, params) {
	if ( !requiredFields ) return;
	if ( requiredFields.length == 0 ) return;
	var field = null;
	var satisfied = false;
	for ( i = 0; i < requiredFields.length; i++ ) {
		satisfied = false;
		// verify required field
		if ( requiredFieldsEvalJS && (requiredFieldsEvalJS.length > i) && requiredFieldsEvalJS[i] ) {
			// verify by eval JS
			satisfied = eval(requiredFieldsEvalJS[i]);
		} else {
			// verify by checking value
			field = document.getElementById(requiredFields[i]);
			if ( field ) {
				if ( field.style.visibility == 'hidden' ) {
					satisfied = true;
				} else if ( (field.value) && (field.value != '') ) {
					satisfied = true;
				} else {
					satisfied = false;
				}
			} else {
				// couldn't find field element, assume it's satisfied
				satisfied = true;
			}
		}
		// there's one required field not met. Break out of loop
		if ( !satisfied ) break;
	}
	if ( requiredFieldsExecJS ) {
		eval(requiredFieldsExecJS);
	}
	if ( buttonName ) {
		// enable or disable button
		if ( buttonName.indexOf(',') == -1 ) {
			enableNCButtonComponent(buttonName, satisfied); 
		} else {
			var buttons = buttonName.split(',');
			for ( i = 0; i < buttons.length; i++ ) {
				enableNCButtonComponent(buttons[i], satisfied); 
			}
		}
	}
}
//-- END: Form Check

/*****************************************************************************
 * Error Message Handling Functions                                          *
 ****************************************************************************/

// Function to display an error in a Javascipt "alert"
// message box.
function report_error(error, msg) {
  var regExp = /\+/g;
  if(!error) {
    alert(decodeURI(String(msg).replace(regExp, ' ')));
  }
} // end function report_error

// pops up new window with url, stripped of most accoutrements, and
// centers it to the screen
// (would've loved to center it to center of calling window but
// the properties required for this op are only under Navigator)
// this window can act as a confirmation dialog to replace confirm()
function minimal_popup(url,target,wd,ht,scroll,resizable) {

  var scrolltxt = "no";
	var coord = getCenterCoordinates(wd, ht);
	var screenX = ns?'screenX='+coord[0]:'left='+coord[0];
	var screenY = ns?'screenY='+coord[1]:'top='+coord[1];
  if ( !resizable ) 
    resizable = 'no';
  else 
    resizable = 'yes';

  if(scroll) scrolltxt="yes";

  weasel = popup_window(url,target,
    'width='+wd+',height='+ht+',' +  
    'status=no,resizable=' + resizable + ',toolbar=no,location=no,menubar=no,directories=no,scrollbars='+ 
    scrolltxt);

  // Use screenX and screenY in call to open instead of moveTo so 
  // don't see the window flicker on screen.
  //weasel.moveTo(screen.width/2 - wd/2, screen.height/2 - ht/2);
	return weasel;

} // endfunc minimal_popup

// pops up new window with url and centers it to the screen
// @param url url
// @param windowName window name
// @param params window parameters such as status,resizable,toolbar,etc
// @param encodeMBC a boolean whether to do MBC encoding. This
// is a hack for calling method with MBC encoding from href. For
// some reason, it decodes it if calling this method from href
// This is optional
//
function popup_window(url, windowName, params, encodeMBC) {
  if ( encodeMBC ) {
    url = url.replace(/%/g, '%25');
  }
	var coord = getCenterCoordinates(550, 580);
	var screenX = ns?'screenX='+coord[0]:'left='+coord[0];
	var screenY = ns?'screenY='+coord[1]:'top='+coord[1];
	if ( !params ) params = '';
	params = params + ',' + screenX + ',' + screenY;
	
	var winobj = window.open(url, windowName, params, true);
         if(winobj) 
          winobj.focus();
        return winobj;
} 

// Function to display default error page in a minimal popup browser. Can be 
// used in onLoad method of page to detect and report any errors encountered 
// in the page. The error msg passed through this function no longer has to 
// be URLEncoded, or encodeURId. It will be taken care of internally to this 
// function. No harm done if already encoding.
function popup_error(error, msg, contextPath) {
  if (error) {
    var url = contextPath ? contextPath : "";
    url += "/servlet/com.micromuse.common.htmlcomponents.servlets.NCErrorServlet?error=";

   // NCErrorPage will take care of decoding the msg.
   minimal_popup(url+encodeURI(msg), "errorPage", 500, 250, true);
  } 
} // end function popup_error


// Function to bypass loading of current page and redirect to default error page.
function redirect_error(error, msg, contextPath) {
  if (error) {
    var url = contextPath ? contextPath : "";
    url += "/servlet/com.micromuse.common.htmlcomponents.servlets.NCErrorServlet?error=";

    window.top.location = url+encodeURI(msg);
  } 
}
/*****************************************************************************
* END common library of general usefulness                                   *
******************************************************************************/

/******************************************************************************
* START NCDoubleComboBoxBasic specific functions.                             *
******************************************************************************/

/******************************************************************************
* START NCDoubleComboBoxBasic specific functions.                             *
******************************************************************************/

function DoubleCombo_optionSelected(listname, formname) {
  // 1. get selected index of listname_1
  // 2. retrieve value of the option at this index
  // 3. clear current secondary list
  // 4. using listname.value, loop through array and populate second list

  var primary = document.getElementById(listname+"_1");
  var secondary = document.getElementById(listname+ "_2");  // points to secondary Select
  var idx = primary.selectedIndex;
  if(idx < 0) { return; } // nothing selected

  var val = primary.options[idx].value;
  // Fix for bug 31562. Convert any spaces into "_", because Oracel can have
  // schema with space in it and javascript cannot handle anything in the form
  // of "TABLE_NAME.blah blah" for a variable name that this components javascript
  // code uses.
  var regExp = / /g;
  val = val.replace(regExp, "_");

  //This is the fix for bug LON0132930..variable of kind TABLE_NAME.12345 is not allowed so I prefixed
  //it (see SQLDataTypeconfigServlet.java). 
  if (isDigit(val.charAt(0))) {
    val = "prefix" + val;
  }
  // 3
  secondary.options.length=0;

  // 4
  if( null == eval(listname + "." + val) ) { return; }  // no secondary list

  var listlen = eval(listname + "." + val + ".length");
  //  alert("DoubleCombo_optionSelected: listlen "+listlen);
  var itemtext;
  var itemval;

  for(var i = 0; i < listlen; i++) {
    itemtext = eval(listname + "." + val + "[" + i + "].text");
    itemval = eval(listname + "." + val + "[" + i + "].value");
    secondary.options[i] = new Option(itemtext, itemval);
  }

} // endfn DoubleCombo_optionSelected


function DoubleCombo_selectSecondOption(optvalue, listname, formname) {
  // 1. loop through secondary list
  // 2. find match to optvalue
  // 3. set second list selection by index of the matched item

  // ref to second list
  //  var list2 = eval("document." + formname + "." + listname + "_2");
  var list2 = document.getElementById(listname + "_2");
  var listlen = list2.options.length;
  //  alert("DoubleCombo_selectSecondOption list2.length "+listlen);
  var itemval;

  for(var i = 0; i < listlen; i++) {
    itemval = list2.options[i].value;
    if(itemval == optvalue) {
      list2.selectedIndex = i; // found! select and get out.
      return;
    }
  }

  return; // value not found, no selection made

} // endfn DoubleCombo_optionSelected

/******************************************************************************
* END NCDoubleComboBoxBasic specific functions.                               *
******************************************************************************/

function do_help_button(href) {
  window.open(href);
}


//move the scripts frame.js to here
/**
 * frame.js is used as the helper of modal dialog. if appliaction 
 * wanna the popup window to be a modal dialog, application will have
 * to include this script file into the very top frame
 */

var newWin;
 
function ignoreEvents(e)
{
  if(!newWin.closed) {
    return false;
  }
}

function focusing() {
  if(newWin && !newWin.closed) {
    newWin.focus();
  }
}

function launchModalDialog(url, winName, w,  h, multiWindow, windowOpener) {
	if ( !window.dialogWinParents )
		window.dialogWinParents = new Array();
	// save dialog parent window. In dialog window, use 
	// self.opener.dialogWinParents[self.opener.newWin.name] to
	// get the parent window. This is an alternative instead of
	// using findFrameObj to look for the parent window
	window.dialogWinParents[winName] = windowOpener;
	window.dialogWinParent = windowOpener;

  var multi = multiWindow ? multiWindow : false;
	var coor = getCenterCoordinates(w, h);
	var screenX = ns?'screenX='+coor[0]:'left='+coor[0];
	var screenY = ns?'screenY='+coor[1]:'top='+coor[1];
  newWin = window.open(url,winName,'width='+w+',height='+h+',status=no,scrollbars=yes,resizable=yes,dependent=yes,'+screenX+','+screenY);

	// This is weird.... After openning window, it doesn't 
	// return back unless user click on the parent window. So we
	// checked if the window was closed before continuing.
	if ( newWin.closed ) return;
	// This is to clear the dialogWinParents array element when
	// dialog window was closed. It doesn't seem to work but
	// it's not affecting anything.
	newWin.onclose = new Function("if ( self.opener.dialogWinParents ) self.opener.dialogWinParents['"+winName+"']=null; window.dialogWinParent=null;");

  if(!multi) {
    blockMyFrames(window.top);
  }
  newWin.focus();
	return newWin;
}

function blockMyFrames(myWin) {
  if (myWin.frames != null ) {
    for (var i=0; i < myWin.frames.length; i++) {
      window.top.blockMyFrames(myWin.frames[i]);
    }
  }
  myWin.document.body.onfocus=window.top.focusing;
  myWin.document.body.onclick=window.top.focusing;
  myWin.document.body.ondbclick=window.top.focusing;
  myWin.onfocus=window.top.focusing;
}
//end of frame.js

/**
 *Simulation of a modal dialog. This dialog will always stays on top. 
 */
//alert(navigator.appName);
var Nav4=((navigator.appName == "Netscape")&&(parseInt(navigator.appVersion) >=4));
var IE=(navigator.appName == "Microsoft Internet Explorer");
var winModalWindow = null;
 
function ignoreEvents(e)
{
  return false;
}

function focusOnPopup() {
  if (winModalWindow != null && !winModalWindow.closed){
    winModalWindow.focus();
  }
}

function handleFocus()
{
  if (winModalWindow != null) {
    if (!winModalWindow.closed) {
       winModalWindow.focus()
    } else {
      window.top.releaseEvents(Event.CLICK|Event.FOCUS);
    }
  }
  return false;
}

function showDialogWindow(url, windowName, w, h, multiWindow) {
 url = encodeURI(url);
  if(typeof(w) == "undefined") {
    w=400;
  }
  if(typeof(h) == "undefined") {
    h=300;
  }
	if ( !windowName || (windowName == '') ) {
		if ( window.top.dialogWinParents ) {
			windowName = 'dialogwin' + new Date().getTime();
			windowName = 'dialogwin' + window.top.dialogWinParents.length;
		} else {
			windowName = 'dialogwin' + new Date().getTime();
		}
	} else {
          // Fix for bug 31971. windowName can contain only alphanumeric 
          // or underscore characters. Must remove (cannot escape!) any 
          // spaces or special chars or IE will give invalid argument error
          // and not launch dialog.
          windowName = windowName.replace(/ |:|;|!|@|#|$|%|^|(|)|&|,|.|\*/g, '');
	}
  if(!Nav4) {
    w += 50;
    h += 50;
    return window.top.launchModalDialog(url, windowName, w, h, multiWindow, window);
  } else {
		var coor = getCenterCoordinates(w, h);
		var screenX = coor[0];
		var screenY = coor[1];
    winModalWindow = window.open(url, windowName,'width='+w+',height='+h+',status=no,scrollbars=yes,resizable=yes,dependent=yes,screenX='+screenX+',screenY='+screenY);
    window.top.captureEvents(Event.CLICK|Event.FOCUS);
    window.top.onfocus=handleFocus;
    window.top.onclick=ignoreEvents;
    if (winModalWindow != null) {
      winModalWindow.focus();
    }
		return winModalWindow;
  }
  
}
/******************************************************************************
* END of modal dialog specific functions.                                     *
******************************************************************************/

/******************************************************************************
* Functions to find frames by frameName in multi-framed environments.         *
******************************************************************************/
/*
 * Function to find and return a reference to a frame window based on the
 * given frameName. Frames must have unique names to ensure proper frame object 
 * is returned. If more than one frame exists with the same name, the frame 
 * window object for the first one found will be returned.
 */
function findFrameObj(frameName) {
  var i, j = 0;
  var parentObj = top;
  var frameObj = null;
  var done = false;
  var nextArray = new Array();

  if (!isDefined(frameName)) {
    done = true;
  }

  while (!done) {
    //alert(parentObj.name+":"+parentObj.frames.length);

    for (i = 0; i < parentObj.frames.length; i++) {
      //alert(parentObj.frames[i].name);
      if (parentObj.frames[i].name == frameName) {
        done = true;
        frameObj = parentObj.frames[i];
        //alert("found toolbar frame");
        break;
      } else if (parentObj.frames[i].frames && parentObj.frames[i].frames.length > 0) {
        nextArray[nextArray.length] = parentObj.frames[i];
        //alert("added "+parentObj.frames[i].name+" to the next array");
      }
    }

    //alert("done with for loop with: "+j+":"+nextArray.length);
    if (!done && j < nextArray.length) {
      //alert("Making parent next: "+nextArray[j].name);
      parentObj = nextArray[j++];
      //alert(parentObj.name);
    }  else {
      //alert("gettin outta here!");
      done = true;
    }
  }
  return (frameObj);
}

function findFrameObjInOpener(frameName) {
  var i, j = 0;
  var parentObj = top.opener.top;
  var frameObj = null;
  var done = false;
  var nextArray = new Array();

  while (!done) {
    //alert(parentObj.name+":"+parentObj.frames.length);

    for (i = 0; i < parentObj.frames.length; i++) {
      //alert(parentObj.frames[i].name);
      if (parentObj.frames[i].name == frameName) {
        done = true;
        frameObj = parentObj.frames[i];
        //alert("found toolbar frame");
        break;
      } else if (parentObj.frames[i].frames && parentObj.frames[i].frames.length > 0) {
        nextArray[nextArray.length] = parentObj.frames[i];
        //alert("added "+parentObj.frames[i].name+" to the next array");
      }
    }

    //alert("done with for loop with: "+j+":"+nextArray.length);
    if (!done && j < nextArray.length) {
      //alert("Making parent next: "+nextArray[j].name);
      parentObj = nextArray[j++];
      //alert(parentObj.name);
    }  else {
      //alert("gettin outta here!");
      done = true;
    }
  }
  return (frameObj);
}

/*
 * Function to find and return a reference to the toolbar frame window object in 
 * a multi-framed environment. Use this function to get to the window that has
 * loaded toolbar.js so toolbar and toolbar button manipulation functions can
 * be found and used.
 */
function getToolBarFrame() {
  return (findFrameObj('toolbar'));
}

/*
 * Function to find and return a reference to the toolbar's content frame window 
 * object in a multi-framed environment.
 */
function getToolBarContentFrame() {
  return (findFrameObj('toolbar_content'));
}

/******************************************************************************
* End find frame window object functions.                                     *
******************************************************************************/
function textbox_onkeydown(field, enabled) {
  var allowEnter = enabled ? enabled : false;
  if (allowEnter) {
    var formName = null;
    if((window.event != null)&&(window.event.keyCode==13) ){
      formName = field.form.name;
    } else if ( arguments.callee.caller.arguments[0]!=null &&
                arguments.callee.caller.arguments[0].keyCode==13) {
      formName = field.form.name;
    }
    if (formName != null && document.forms[formName]) {
      //alert("Submitting: "+formName);
      document.forms[formName].submit();
      return false;
    } else {
      return true;
    }
  } else {
    if((window.event != null)&&(window.event.keyCode==13) ){
      return false;
    } else if ( arguments.callee.caller.arguments[0]!=null &&
        	arguments.callee.caller.arguments[0].keyCode==13) {
      return false;
    }
  }
}

/******************************************************************************
* Cookie functions.                                                           *
******************************************************************************/
function getCookie (sName) {
  //alert("getCookie: "+document.cookie);
  var re = new RegExp( "(\;|^)[^;]*(" + sName + ")\=([^;]*)(;|$)" );
  var res = re.exec(document.cookie);

  var res_temp = res != null ? res[3] : null;
  //alert("res_temp: " + res_temp);

  return res_temp;
}

function setCookie(sName, sValue, nDays) {
  var expires = "";
  //alert("nDays: " + nDays);
  if (nDays) {
    var d = new Date();
    d.setTime(d.getTime() + nDays * 24 * 60 * 60 * 1000);
    expires = "; expires=" + d.toGMTString();
    //alert("expire: "+expires);
  }
  document.cookie = sName + "=" + sValue + expires + "; path=/";
  //alert("setCookie: "+document.cookie);
}

function removeCookie (name) {
  setCookie(name, "", -1 );
}
/******************************************************************************
* End cookie functions.                                                       *
******************************************************************************/  

/******************************************************************************
* Functions to take window.location and extract out params portion of url     *
******************************************************************************/
function extractURIFromURL(url) {
  var tmpUrl = typeof(url) != "undefined" ? url : "";
  //alert("tmpUrl (before): "+tmpUrl);
  var i = tmpUrl.indexOf("\/\/");
  if (i > 0) {
    i = tmpUrl.indexOf("\/", i+2);
    if (i > 0) {
      tmpUrl = tmpUrl.slice(i, tmpUrl.length);
    }
  }
  //alert("tmpUrl (after): "+tmpUrl);
  return (tmpUrl);
}

function extractParamsFromUrl(window) {
  var url = new String(window.location);
  var i = url.indexOf("?");
  var params = null;
  if (i > 0) {
    params = new String(url.slice(i+1,url.length));
  }
  return (params);
}

function removeNameValuePair(paramsStr, name) {
  var returnStr = paramsStr;
  var tmp = new String(paramsStr);
  if (tmp != null && name != null) {
    var i = tmp.indexOf(name);
    if (i >= 0) {
      returnStr = new String (tmp.slice(0,i));
      var j = tmp.indexOf("&", i);
      if (j > 0) {
        returnStr += tmp.slice(j+1,tmp.length);
      }
    }
  } 
  return (returnStr);
} 
/******************************************************************************
* End window.location functions.                                              *
******************************************************************************/
function submitFormInAnotherFrameToTarget(frameName, form, href, targetPage) {
  //alert(frameName);
  eval("frameName.document."+form+".target=targetPage");
  eval("frameName.document."+form+".action=href");
	var fakebutton = eval("frameName.document." + form + ".fakesubmitbutton");
	if ( fakebutton ) fakebutton.click();
  else eval("frameName.document."+form+".submit()");
}

function relogin(context) {
  var contextPath = isDefined(context) ? context : "";
  if (top.opener == null) {
    // Redirect to main index page.
    //top.location.href = contextPath+'/login';
    top.location.href = '/index.html';
  } else {
    // Redirect to main index page.
    //top.opener.top.location.href = contextPath+'/login';
    top.opener.top.location.href='index.html';
    top.close();
  }
}

/******************************************************************************
* Functions for javascript buttons embeded within page.                       *
******************************************************************************/
var buttonContainer = new NCButtonContainer();

function createJSForButtons() {
  //alert("createJSForButtons.......creating buttons array");
  var imgs = document.getElementsByTagName("img");
  //alert("Num of imgs: "+imgs.length);
  for (var i = 0; i < imgs.length; i++) {
    //alert(imgs.item(i).getAttribute("ncattribclass"));
    if (imgs.item(i).getAttribute("ncattribclass") != null && 
        imgs.item(i).getAttribute("ncattribclass") == "button") {
      var imgName = imgs.item(i).getAttribute("src");
      var j = imgName.lastIndexOf("/");
      var contextPath = imgName.slice(0, j);
      //alert(imgs.item(i).getAttribute("ncattribstate"));
      //alert(imgs.item(i).getAttribute("ncattribdisableimg"));
      buttonContainer.addButton(new NCButton(imgs.item(i).getAttribute("name"),
                                             imgs.item(i).getAttribute("src"),
                                             contextPath+"/"+
                                             imgs.item(i).getAttribute("ncattribdisableimg"),
                                             imgs.item(i).getAttribute("ncattribstate")));
    }
  }
}

// The var jsForButtonsEnabled is written by NCBasicPage so there
// is one per page.
function canDoNCButtonClick(name) {
  if (jsForButtonsEnabled && !isNCButtonEnabled(name)) {
    return false;
  }
  return true;
}

// Define a javascript button object.
function NCButton(name, icon, icon_disabled, state) {
  var enabledState = state ? state : "enabled";
  
  this.name = name ? name : "";

  // Very important to preload the images!
  // Lots of swapping of images based on state.
  // Must make sure they are all loaded!
  this.icon = new Image();
  this.icon.src =  icon ? icon : "";

  this.icon_disabled = new Image();
  if (name == "apply") {
    this.icon_disabled.src = "/netcool/images/button_cancel.png";
  } else {
    this.icon_disabled.src = icon_disabled ? icon_disabled : "";
  }

  this.enabled = (enabledState == "disabled") ? false : true;

  this.enableSelf = enableSelf;

  if (!this.enabled) {
    this.enableSelf(false);
  }
}

/*
 * Button sets self as enabled or disabled to keep track of state.
 */
function enableSelf(enable) {
  //alert("enablingSelf:\n"+this.name+" to "+enable);
  this.enabled = enable;
  swapImage(this.name, (this.enabled ? this.icon.src : this.icon_disabled.src));
} 
// End javascript button object.

// Define a button container object for an NCBasicPage. Button container is
// one per page.
function NCButtonContainer() {
  this.buttons = new Array();
  this.addButton = addButtonToContainer;
  this.findButton = findButtonInContainer;
}

/*
 * Function to add a button to a button container. Button container is one 
 * per NCBasicPage.
 */
function addButtonToContainer(button) {
  //alert("Adding button:\n"+button.name+"\n"+button.icon.src+"\n"+
  //       button.icon_disabled.src+"\n"+button.enabled);
  this.buttons[this.buttons.length] = button;
}

/*
 * Function to find and return a toolbar button
 * in the toolbar's array of buttons.
 */
function findButtonInContainer(name) {
  var i; 
  var button = null;
  
  for (i = 0; i < this.buttons.length; i++) {
    if (this.buttons[i].name == name) {
      button = this.buttons[i]; 
      break; 
    }
  }
  return (button);
}
// End javascript button object.

/*
 * Enable or disable a button in an NCBasicPage.
 * Note: Javascript variable buttonContainer is defined and set in page
 * by NCBasicPage.
 */
function enableNCButton(name, enable) {
  if (typeof(buttonContainer) != "undefined") {
    var button = buttonContainer.findButton(name);
    if (button) {
      button.enableSelf(enable);
    }
  }
}

/*
 * Returns enabled state for button in an NCBasicPage.
 * Note: Javascript variable buttonContainer is defined and set in page
 * by NCBasicPage.
 */
function isNCButtonEnabled(name) {
  if (typeof(buttonContainer) != "undefined") {
    var button = buttonContainer.findButton(name);
    if (button) {
      return (button.enabled);
    }
  }
  return ("undefined");
}
/******************************************************************************
* End functions for javascript buttons embeded within page.                   *
******************************************************************************/

/******************************************************************************
* Functions for javascript adding/removing NCDynamicTable rows.               *
******************************************************************************/
/**
 * Add a row to NCDynamicTable.
 * NOTE: This works with NCDynamicTable with or without deleteable turned on. It 
 * works with edit column if there is at least 1 row in the table
 * @param tablename a tablename, null or '' if none
 * @param datarow an array of text
 * @param isdeletable a boolean whether to include a checkbox column
 * @param deleteid delete ID
 * @param iseditable a boolean whether to include an edit column 
 */
 function addNCDynamicTableRow(tablename, datarow, isdeletable, deleteid, iseditable) {
	if ( !datarow || datarow.length == 0 ) return; // cannot empty rows
	if ( !tablename ) tablename = '';
	var tbody = document.getElementById(tablename + 'databody');
	var tritems = tbody.getElementsByTagName('tr');
	var row = tritems.length;
	var tr = document.createElement("TR");
	tr.setAttribute("id", "row" + row);
	if ( isdeletable ) {
		if ( !deleteid ) deleteid = row;
		var newinputcell = document.createElement("TD");
		var inputstr = (ie)?'<INPUT deleteTXT="' + deleteid + '" name="deleteUID">':'INPUT';
		var newcb = document.createElement(inputstr);
		newcb.setAttribute('name', 'deleteUID');
		newcb.setAttribute('deleteTXT', deleteid);
		newcb.type = 'CHECKBOX';
		newcb.value = deleteid;
		newcb.onclick = new Function("setSelectedRow(" + row + ");");
		newinputcell.setAttribute('align', 'center');
		newinputcell.className = 'TBLheader';
		newinputcell.appendChild(newcb);
		tr.appendChild(newinputcell);
	}
	var newcell;
	for ( a = 0; a < datarow.length; a++ ) {
		newcell = document.createElement("TD");
		newcell.setAttribute('style', 'overflow: hidden;');
		newcell.setAttribute('align', 'left');
		if ( (row)%2 == 1 ) tr.className = 'TBLaltRow';
		newcell.appendChild(document.createTextNode(datarow[a]));
		tr.appendChild(newcell);
	}
	if ( iseditable ) {
		if ( tritems.length > 0 ) {
			// we can only add this if there's 1 or more rows in the table
			var tditems = tritems[0].getElementsByTagName("TD");
			var neweditcell = null;
			for ( a = tditems.length - 1; a > 0; a-- ) {
				if ( tditems[a].innerHTML.indexOf('button_edit') != -1 ) {
					neweditcell = tditems[a].cloneNode(true); 
					break;
				}
			}
			if ( neweditcell ) {
				var edithtml = neweditcell.innerHTML;
				edithtml = edithtml.replace(/editCurrentRow\(\'\d+\'\)/g, 'editCurrentRow(\'' + row + '\')');
				edithtml = edithtml.replace(/\'e\d+\'/g, '\'e' + row + '\'');
				edithtml = edithtml.replace(/\"e\d+\"/g, '"e' + row + '"');
				neweditcell.innerHTML = edithtml;
				tr.appendChild(neweditcell);
			}
		}
	}
	var newcell;
	for ( a = 0; a < datarow; a++ ) {
		newcell = document.createElement("TD");
		newcell.setAttribute('style', 'overflow: hidden;');
		newcell.setAttribute('align', 'left');
		if ( (row)%2 == 1 ) tr.className = 'TBLaltRow';
		newcell.appendChild(document.createTextNode(datarow[a]));
		tr.appendChild(newcell);
	}
	tbody.appendChild(tr);
	setSelectedRow(row, true);
}

/**
 * Delete selected rows from NCDynamicTable.
 * NOTE: This won't work with no edit column and/or move column
 * @return a list of deleted rows' deleteUID separated with comma's.
 */
function deleteNCDynamicTableRows() {
	var uids = '';
	var delobj = document.mainForm.deleteUID;
	var tbody = document.getElementById('databody');
	var tritems = tbody.getElementsByTagName('tr');
	if ( delobj.length ) {
		var cblength = delobj.length;
		var initrow = false;
		var j = 0;
		for ( i = 0; i < delobj.length; i++ ) {
			selectedIDs[j++] = null;
			if ( delobj[i].checked ) {
				if ( (i+1) < tritems.length ) {
					tritems[(i+1)].className = (i%2)?'TBLaltRow':'';
				}
				if ( tritems[i] ) {
					uids = uids + delobj[i].value + ',';
					tbody.removeChild(tritems[i]);
				} else break;
				i--;
				initrow = true;
				continue;
			}
			if ( initrow ) {
				tritems[i].id = 'row' + i;
				setSelectedRow(i, true);
				delobj[i].onclick=new Function('setSelectedRow(' + i + ');');
			}
		} 
		if ( uids.length > 1 ) {
			uids = uids.substring(0, uids.length-1);
		}
	} else if ( delobj.checked ) { 
		selectedIDs[0] = null;
		uids = delobj.value;
		tbody.removeChild(tritems[0]);
	} 
	return uids;
}
/******************************************************************************
* End functions for javascript adding/removing NCDynamicTable rows            *
******************************************************************************/

/****************************************************************************
* Functions for use by applcations that are content of dynamic tabpanes.    *
*****************************************************************************/
// Function to tell dynamic tabpane save is in progress.
function notifyTabPaneSaveInProgress(tabpaneFrameName, isSaving) {
  var tabpaneFrameObj = findFrameObj(tabpaneFrameName);
  if (tabpaneFrameObj != null) {
    var isSavingFlag = isDefined(isSaving) ? isSaving : true;
    tabpaneFrameObj.notifySaveInProgress(isSavingFlag);
  }
}

// Function to query tabpane to see if save is in progress.
function isTabPaneSaveInProgress(tabpaneFrameName) {
  var tabpaneFrameObj = findFrameObj(tabpaneFrameName);
  if (tabpaneFrameObj != null) {
    return (tabpaneFrameObj.isSaveInProgress());
  }
  return (false);
}

// Function to have dynamic tabpane to store application specific data.
//
// tabpaneName - name of dynamic tabpane application belongs to
// key - unique key to store data under
// value - data to store
function storeDataForTabPaneApplication(tabpaneName, key, data) {
  var tabpaneFrameObj = findFrameObj(tabpaneName);
  if (tabpaneFrameObj != null) {
    tabpaneFrameObj.storeDataInCache(key, data);
  }
}

// Function to have dynamic tabpane to store application specific data.
// Returns data if item with key exists, otherwise null.
//
// tabpaneName - name of dynamic tabpane application belongs to
// key - unique key to store data under
function retrieveDataForTabPaneApplication(tabpaneName, key) {
  var tabpaneFrameObj = findFrameObj(tabpaneName);
  if (tabpaneFrameObj != null) {
    var dataObj = tabpaneFrameObj.retrieveDataFromCache(key);
    if (dataObj != null) {
      return (dataObj.value);
    }
  }
  return (null);
}

// Function to iterate through all frames of current page looking dynamic 
// tabpanes and calling their tabChangeHandlers.
// The tabChangeHandlers are application defined and can alert user of
// whatever application defines on a tabChange.  A tabChange includes, the
// user clicking on a different tab, the user closing a tab or the user 
// adding a new tab.  This function provides a mechanism to call existing
// tabChangeHandlers for all dynamic tabbedpanes found.  This may be useful
// for instance on a page reload.
var tabChangeIsOk = true;
function dynamicTabChangeHandlersOk(parent) {
  var parentObj;
  if (isDefined(parent)) {
    parentObj = parent;
  } else {
    parentObj = top;
    tabChangeIsOk = true;
  }
  //alert("parentObj: "+parentObj+":"+parentObj.frames.length);
  if (!tabChangeIsOk) {
    return (false);
  }
  for (var i = 0; i < parentObj.frames.length && tabChangeIsOk; i++) {
    //alert(parentObj.frames[i].name);
    if (isDefined(parentObj.frames[i].tabChangeHandler)) {
      //alert("Found tabChangeHandler for: "+parentObj.frames[i].name);
      tabChangeIsOk = parentObj.frames[i].tabChangeHandler();
    }
    tabChangeIsOk = dynamicTabChangeHandlersOk(parentObj.frames[i]);
  }
  return (tabChangeIsOk);
}
/********************************************************************************
* End functions for use by applcations that are content of dynamic tabpanes.    *
*********************************************************************************/

/****************************************************************************
* Functions for navigation toggle button.                                   *
*****************************************************************************/
// Function to handle onClickEvent of navigation button. Return true
// to allow navigation panel toggle and false otherwise.
function canDoNavigationToggle() {
  // For once IE handles a javascript problem better than NS.
  // If this is IE resizing frames does not cause them to unload,
  // so no data is lost that user may have entered on page. If,
  // however this is NS, call the tabChangeHandlers for each
  // dynamicTabPane, if they exist, so user is at least warned.
  if (!ie && !dynamicTabChangeHandlersOk()) {
    return (false);
  }
  return (true);
}

// Function to handle onLoad event of navigation button frame. If 
// browser is NS, it will reload frames, we must handle this so
// correct navigation button is showing (e.g. open vs close button).
function onLoadNavigationButtonFrame(framesetId, navImgName, imgPath) {
  var fsId = isDefined(framesetId) ? framesetId : "nav_frame";
  var imagePath = isDefined(imgPath) ? imgPath : "/netcool/images/";
  var framesetObj = parent.document.getElementById(fsId);
  if (!ie && framesetObj != null) {
    var showCols = framesetObj.getAttribute("show_cols");
    var hideCols = framesetObj.getAttribute("hide_cols");
    var showRows = framesetObj.getAttribute("show_rows");
    var hideRows = framesetObj.getAttribute("hide_rows");
    var navState = getCookie(fsId+"_navState");
    var isHidden = (isDefined(navState) && navState == "0") ? true : false;
    if (isHidden && (hideCols != null) && (framesetObj.cols == hideCols)) {
      if (isDefined(navImgName)) {
        swapImage(navImgName, imagePath+"icon_open_navigation.png");
      }
    }
  }
}

function toggleNavigationFrame(framesetId, navImgName, imgPath) {
  var fsId = isDefined(framesetId) ? framesetId : "nav_frame";
  var imagePath = isDefined(imgPath) ? imgPath : "/netcool/images/";
  var framesetObj = parent.document.getElementById(fsId);
  if (framesetObj != null) {
    var showCols = framesetObj.getAttribute("show_cols");
    var hideCols = framesetObj.getAttribute("hide_cols");
    var showRows = framesetObj.getAttribute("show_rows");
    var hideRows = framesetObj.getAttribute("hide_rows");
    //alert("showCols:hideCols "+showCols+":"+hideCols);
    //alert("showRows:hideRows "+showRows+":"+hideRows);
    //alert("currentCols: "+framesetObj.cols);
    if (hideCols != null && showCols != null) {
      if (framesetObj.cols == hideCols) {
        //alert("showing nav frames");
        if (isDefined(navImgName)) {
          swapImage(navImgName, imagePath+"icon_close_navigation.png");
        }
        setCookie(fsId+"_navState", "1");
        framesetObj.setAttribute("cols", showCols);
      } else {
        //alert("hiding nav frames");
        if (isDefined(navImgName)) {
          swapImage(navImgName, imagePath+"icon_open_navigation.png");
        }
        setCookie(fsId+"_navState", "0");
        framesetObj.setAttribute("cols", hideCols);
      }
    }
    if (hideRows != null && showRows != null) {
      if (framesetObj.rows == hideRows) {
        //alert("showing nav frames");
        if (isDefined(navImgName)) {
          swapImage(navImgName, imagePath+"icon_close_navigation.png");
        }
        setCookie(fsId+"_navState", "1");
        framesetObj.setAttribute("rows", showRows);
      } else {
        //alert("hiding nav frames");
        if (isDefined(navImgName)) {
          swapImage(navImgName, imagePath+"icon_open_navigation.png");
        }
        setCookie(fsId+"_navState", "0");
        framesetObj.setAttribute("rows", hideRows);
      }
    }
  } else {
    alert("Cannot toggle navigation panel. No framesetObj found!");
  }
}
/****************************************************************************
* End functions for navigation toggle button.                               *
*****************************************************************************/

/****************************************************************************
* Functions for logobar service navigation list.                            *
* Note: Vars currApp, selectedUrl, idToSelect and mainFrameObj are global   *
* to page and written by NCLogoBarServlet.                                  * 
*****************************************************************************/
function onLoadNCLogoBar() {
  currApp = getCookie('ncCurrApp');
  //alert("begin cookie: "+currApp);
  //alert("begin idToSelect: "+idToSelect);
  var serviceSelect = null;
  var serviceList = null;
  var selects = document.getElementsByTagName("select");
  var usingCurrAppCookie = false;
  var selectedHelpFile = null;
  for (var i = 0; i < selects.length; i++) {
    if (selects.item(i).getAttribute("name") != null &&
        selects.item(i).getAttribute("name") == "logoBarServiceNav") {
      serviceSelect = selects.item(i);
      serviceList = serviceSelect.options;
      break;
    }
  }
  if (serviceList != null) {
    if (currApp != null && currApp > -1) { 
      if (currApp < serviceList.length) {
        selectedUrl = serviceList[currApp].value; 
        //alert("1 selectedUrl: "+selectedUrl);
        serviceSelect.selectedIndex = currApp;
        //alert("1 selectedIndex: "+serviceSelect.selectedIndex);
        selectedHelpFile =
          serviceList[currApp].getAttribute('ncattribhelppath');
        usingCurrAppCookie = true;
      } else {
        removeCookie('ncCurrApp');
      }
    } 
    if (!usingCurrAppCookie && isDefined(idToSelect)) {
      if (idToSelect == -1) {
        idToSelect = 0;
      }
      setCookie('ncCurrApp', idToSelect);
      if (idToSelect > -1) {
        selectedUrl = serviceList[idToSelect].value;
        //alert("2 selectedUrl: "+selectedUrl);
        serviceSelect.selectedIndex = idToSelect;
        //alert("2 selectedIndex: "+serviceSelect.selectedIndex);
        selectedHelpFile =
          serviceList[idToSelect].getAttribute('ncattribhelppath');
      }
    }
  }
  if (isDefined(mainFrameObj) && selectedUrl != null) {
    var mainFrameUrl = extractURIFromURL(mainFrameObj.location.href);
    selectedUrl = extractURIFromURL(selectedUrl);
    if (mainFrameUrl != selectedUrl) {
      mainFrameObj.location.replace(selectedUrl);
    }
    // Make sure the help button always reflects the proper help.
    // Set help file for main help button in logobar.
    var helpButton = document.getElementById('button_logobar_help');
    if (isDefined(helpButton) && isDefined(selectedHelpFile)) {
       helpButton.href = selectedHelpFile;
    }
  }
}

// Note: the first item in the services navigation list is "Please Select".
function onChangeNCLogoBarNavigationList(serviceSelect) {
  if (isDefined(serviceSelect)) {
    removeCookie('ncCurrApp');
    var selected = serviceSelect.selectedIndex;
    if (selected == -1) {
      // "Please select" will always be 1st item in services list.
      selected = 0;
    }
    setCookie('ncCurrApp', selected);
    var selectedUrl = null;
    var selectedHelpFile = null;
    if (selected < serviceSelect.length) {
      selectedUrl = serviceSelect.options[selected].value;
      selectedHelpFile = 
        serviceSelect.options[selected].getAttribute('ncattribhelppath');
    }
    if (isDefined(mainFrameObj) && selectedUrl != null) {
      var mainFrameUrl = extractURIFromURL(mainFrameObj.location.href);
      selectedUrl = extractURIFromURL(selectedUrl);
      if (mainFrameUrl != selectedUrl) {
        mainFrameObj.location.href = selectedUrl;
        // Set help file for main help button in logobar.
        var helpButton = document.getElementById('button_logobar_help');
        if (isDefined(helpButton) && isDefined(selectedHelpFile)) {
          helpButton.href = selectedHelpFile;
        }
      }
    }
  }
}
/****************************************************************************
* End functions for logobar service navigation list.                        *
*****************************************************************************/

function checkPassword(password, confirmPassword) {
 //   alert('password '+password +' newpassword '+confirmPassword);
   //alert("password.length "+password.length);
    if(password == null || password.length == 0) {
	alert("Please enter a valid password");
        return false;
    }
    if(password  == confirmPassword) {
	return true;
    } else {
        alert("Password and confirm password fields don't match");
	return false;
   }
	
}
function containsIllegalSQLChar(input) {
 var ch;
 for(var i = 0 ; i < input.length; i++) {
   ch = input.charAt(i);
   if(ch == '%') {
    alert('Special character '+ch+' not allowed');
    return true;
  }
 }
  return false;
}

/****************************************************************************
* Start functions for NCButton.                        *
*****************************************************************************/
function cancelLink() {
	return false;
}
// Enable/disable NCButton
// @param imageName NCButton image name
// @param set a boolean whether this button is enabled
function enableNCButtonComponent(imageName, set) {
	if ( !imageName ) return;
	var buttonObj = document.getElementById(imageName);
	if ( !buttonObj ) return;
	var buttonSrc = buttonObj.src.substring(0, buttonObj.src.lastIndexOf('.'));
	var tmp = buttonSrc.length;
	if ( (tmp = buttonSrc.indexOf('_over')) != -1 ) {
		buttonSrc = buttonSrc.substring(0, tmp);
	} else if ( (tmp = buttonSrc.indexOf('_click')) != -1 ) {
		buttonSrc = buttonSrc.substring(0, tmp);
	} else if ( (tmp = buttonSrc.indexOf('_disabled')) != -1 ) {
		buttonSrc = buttonSrc.substring(0, tmp);
	}
	var buttonExt = buttonObj.src.substring(buttonObj.src.lastIndexOf('.'), buttonObj.src.length);
	var bdisablevar = eval('is' + imageName + 'Disabled');
	var buttonLink = document.getElementById(imageName + '_link');
	if ( set ) {
	 	// enable button
		eval('is' + imageName + 'Disabled = false');
		bdisablevar = false;
		buttonObj.src = buttonSrc + buttonExt;
		if ( buttonLink != null ) {
			// enable link
			if ( buttonLink.oldOnclick ) buttonLink.onclick = buttonLink.oldOnclick;
			buttonLink.disabled = false;
		}
	} else {
		// disable button
		bdisablevar = true;
		eval('is' + imageName + 'Disabled = true');
		buttonObj.src = buttonSrc + "_disabled" + buttonExt;
		if ( buttonLink != null ) {
			// disable link
			if ( !buttonLink.srcbk ) {
				// we only save the link href the first time
				buttonLink.srcbk = buttonLink.href;
			}
			if ( !buttonLink.oldOnclick ) {
				buttonLink.oldOnclick = buttonLink.onclick;
			}
			buttonLink.onclick = cancelLink;
			buttonLink.disabled = true;
		}
	}
}

/****************************************************************************
* End functions for NCButton.                        *
*****************************************************************************/

/****************************************************************************
* Functions for use by NCAccumulator    *
*****************************************************************************/
function moveSelectedOptions(clientId, from, to, isAdd, sort, isMultiple) {
  var fromsel = document.getElementById(from);
  var tosel = document.getElementById(to);
  var opts = fromsel.options;
  var dopts = tosel.options;
  if ( dopts.length==1 && dopts[0].value=='Dummy' ) { 
		dopts[0]=null; 
	}
	var isSelectedItem = false;
  for ( var i=opts.length-1; i>=0;i-- ) {
		var o = opts[i];
  	if ( o.selected ) {
			isSelectedItem = true;
   		dopts[dopts.length]=new Option(o.text, o.value, false, false); 
			opts[i]=null;
		}
	}
	if ( !isSelectedItem ) {
		// no need to continue if there were no selected items
		return;
	}

  dopts.selectedIndex = -1;
  var toopts = dopts;
  if ( !isAdd ) {
  	toopts = opts;
	}
	// update list
  eval('updateSelectedListValue' + clientId + 'toList(clientId, toopts)');

  if ( !isMultiple ) {
   	if ( isAdd ) 
   		enableNCButtonComponent(clientId + 'add', false);
   	else 
   		enableNCButtonComponent(clientId + 'add', true);
  }
  if ( sort ) {
    sortSelect(fromsel);
    sortSelect(tosel);
  }
	return true;
}
    
function moveAllOptions(clientId, from, to, isAdd, isMultiple) {
  var fromsel = document.getElementById(from);
  var tosel = document.getElementById(to);
  var opts = fromsel.options;
  var dopts = tosel.options;
  if ( dopts.length==1 && dopts[0].value=='Dummy' ) { 
		dopts[0]=null;
	}
	var o = null;
  for ( var i = opts.length-1; i >= 0; i-- ) { 
  	o = opts[i];
    dopts[dopts.length] = new Option(o.text, o.value, false, false); 
		opts[i]=null;
	}
  dopts.selectedIndex = -1;
  if ( !isMultiple ) {
  	if ( isAdd ) 
  		enableNCButtonComponent(clientId + 'add', false);
  	else 
    	enableNCButtonComponent(clientId + 'add', true);
  }
  if ( sort ) {
    sortSelect(fromsel);
    sortSelect(tosel);
  }
  var toopts = dopts;
  if ( !isAdd ) 
    toopts = opts;
	// update list
  eval('updateSelectedListValue' + clientId + 'toList(clientId, toopts)');
	return true;
}


/****************************************************************************
* End functions for NCAccumulator.                        *
*****************************************************************************/

/************************************************************
* Start functions for progress window functions
*************************************************************/
/**
 * Opens a floating window and loads the specified loadingPageURL.
 * @param loadingPageURL a url to a loading/progressing page
 * If null, a default page is used: /netcool/html/loading.html
 * @param width width of the window. Default 250
 * @param height height of the window. Default 150
 */
function openLoadingWindow(loadingPageURL, width, height) {
	if ( !width ) width = 250;
	if ( !height ) height = 160;
	if ( !loadingPageURL ) loadingPageURL = '/netcool/html/loading.html';
  // don't know what to do here....we need to have a good div floating
  // window to display loading...
}
/************************************************************
* End functions for progress window functions
*************************************************************/

/************************************************************
* Start functions for tab
*************************************************************/
/**
 * Show tab
 * @param tabid tab id
 * @param hiddenTabId hidden input for current tab
 * @param title tab title 
 * @param subtabs sub tab name in comma separated
 * @param parenttabs parent tab names in comma separated
 */
function showTab(tabid, hiddenTabId, title, subtabs, parenttabs) {
	document.getElementById(hiddenTabId).value=tabid;
	var divs = document.getElementsByTagName('div');
	var k = 0;
	var subtabsArr = new Array();
	var subtab = false;
	var parenttabsArr = new Array();
	var parenttab = false;
	if ( subtabs ) subtabsArr = subtabs.split(',');
	if ( parenttabs ) parenttabsArr = parenttabs.split(',');
	for ( k = 0; k < divs.length; k++ ) {
		if ( divs[k].id == tabid ) {
			document.getElementById(tabid).style.visibility = 'visible';
		} else if ( divs[k].id.indexOf('tab_') != -1 ) {
			subtab = false;
			if ( subtabsArr.length > 0 ) {
				for ( i = 0; i < subtabsArr.length; i++ ) {
					if ( divs[k].id.indexOf(subtabsArr[i]) != -1 ) {
						divs[k].style.visibility = 'visible';
						subtab = true;
						break;
					}
				}
				if ( subtab ) continue;
			}
			parenttab = false;
			if ( parenttabsArr.length > 0 ) {
				for ( i = 0; i < parenttabsArr.length; i++ ) {
					if ( divs[k].id.indexOf(parenttabsArr[i]) != -1 ) {
						divs[k].style.visibility = 'visible';
						parenttab = true;
						break;
					}
				}
				if ( parenttab ) continue;
			}
			// hide tab
			divs[k].style.visibility = 'hidden';
		}
	}

}
/************************************************************
* End functions for tab
*************************************************************/

/********************************************************
 * Use this function to encode parameter MBC values
 ********************************************************/
// 
// Encode the specified MBC parameter
//
function encodeParameter(parameter) {
  var encoded = encodeURI(parameter).replace(/%/g, '%25');
  // we don't want to have %2520, sometimes it couldn't decode
  // it
  encoded = encoded.replace(/%2520/g, '%20');
  encoded = encoded.replace(/\'/g, '%2527');
  return encoded;
}
/************************************************************
 * End this function to encode parameter MBC values
 ************************************************************/

